import { setPaginationParams } from "../../../helpers";
export class LCDQueryClient {
    req;
    constructor({ requestClient }) {
        this.req = requestClient;
    }
    /* Account returns account permissions. */
    account = async (params) => {
        const endpoint = `cosmos/circuit/v1/accounts/${params.address}`;
        return await this.req.get(endpoint);
    };
    /* Account returns account permissions. */
    accounts = async (params = {
        pagination: undefined
    }) => {
        const options = {
            params: {}
        };
        if (typeof params?.pagination !== "undefined") {
            setPaginationParams(options, params.pagination);
        }
        const endpoint = `cosmos/circuit/v1/accounts`;
        return await this.req.get(endpoint, options);
    };
    /* DisabledList returns a list of disabled message urls */
    disabledList = async (_params = {}) => {
        const endpoint = `cosmos/circuit/v1/disable_list`;
        return await this.req.get(endpoint);
    };
}
//# sourceMappingURL=query.lcd.js.map