import * as _m0 from "protobufjs/minimal";
import { MsgGrantAllowance, MsgGrantAllowanceResponse, MsgRevokeAllowance, MsgRevokeAllowanceResponse } from "./tx";
export class MsgClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* GrantAllowance grants fee allowance to the grantee on the granter's
     account with the provided expiration time. */
    grantAllowance = async (request) => {
        const data = MsgGrantAllowance.encode(request).finish();
        const promise = this.rpc.request("cosmos.feegrant.v1beta1.Msg", "GrantAllowance", data);
        return promise.then(data => MsgGrantAllowanceResponse.decode(new _m0.Reader(data)));
    };
    /* RevokeAllowance revokes any fee allowance of granter's account that
     has been granted to the grantee. */
    revokeAllowance = async (request) => {
        const data = MsgRevokeAllowance.encode(request).finish();
        const promise = this.rpc.request("cosmos.feegrant.v1beta1.Msg", "RevokeAllowance", data);
        return promise.then(data => MsgRevokeAllowanceResponse.decode(new _m0.Reader(data)));
    };
}
//# sourceMappingURL=tx.rpc.msg.js.map