import * as _m0 from "protobufjs/minimal";
import { MsgSubmitProposal, MsgSubmitProposalResponse, MsgExecLegacyContent, MsgExecLegacyContentResponse, MsgVote, MsgVoteResponse, MsgVoteWeighted, MsgVoteWeightedResponse, MsgDeposit, MsgDepositResponse, MsgUpdateParams, MsgUpdateParamsResponse, MsgCancelProposal, MsgCancelProposalResponse } from "./tx";
export class MsgClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* SubmitProposal defines a method to create new proposal given the messages. */
    submitProposal = async (request) => {
        const data = MsgSubmitProposal.encode(request).finish();
        const promise = this.rpc.request("cosmos.gov.v1.Msg", "SubmitProposal", data);
        return promise.then(data => MsgSubmitProposalResponse.decode(new _m0.Reader(data)));
    };
    /* ExecLegacyContent defines a Msg to be in included in a MsgSubmitProposal
     to execute a legacy content-based proposal. */
    execLegacyContent = async (request) => {
        const data = MsgExecLegacyContent.encode(request).finish();
        const promise = this.rpc.request("cosmos.gov.v1.Msg", "ExecLegacyContent", data);
        return promise.then(data => MsgExecLegacyContentResponse.decode(new _m0.Reader(data)));
    };
    /* Vote defines a method to add a vote on a specific proposal. */
    vote = async (request) => {
        const data = MsgVote.encode(request).finish();
        const promise = this.rpc.request("cosmos.gov.v1.Msg", "Vote", data);
        return promise.then(data => MsgVoteResponse.decode(new _m0.Reader(data)));
    };
    /* VoteWeighted defines a method to add a weighted vote on a specific proposal. */
    voteWeighted = async (request) => {
        const data = MsgVoteWeighted.encode(request).finish();
        const promise = this.rpc.request("cosmos.gov.v1.Msg", "VoteWeighted", data);
        return promise.then(data => MsgVoteWeightedResponse.decode(new _m0.Reader(data)));
    };
    /* Deposit defines a method to add deposit on a specific proposal. */
    deposit = async (request) => {
        const data = MsgDeposit.encode(request).finish();
        const promise = this.rpc.request("cosmos.gov.v1.Msg", "Deposit", data);
        return promise.then(data => MsgDepositResponse.decode(new _m0.Reader(data)));
    };
    /* UpdateParams defines a governance operation for updating the x/gov module
     parameters. The authority is defined in the keeper.
    
     Since: cosmos-sdk 0.47 */
    updateParams = async (request) => {
        const data = MsgUpdateParams.encode(request).finish();
        const promise = this.rpc.request("cosmos.gov.v1.Msg", "UpdateParams", data);
        return promise.then(data => MsgUpdateParamsResponse.decode(new _m0.Reader(data)));
    };
    /* CancelProposal defines a method to cancel governance proposal
    
     Since: cosmos-sdk 0.50 */
    cancelProposal = async (request) => {
        const data = MsgCancelProposal.encode(request).finish();
        const promise = this.rpc.request("cosmos.gov.v1.Msg", "CancelProposal", data);
        return promise.then(data => MsgCancelProposalResponse.decode(new _m0.Reader(data)));
    };
}
//# sourceMappingURL=tx.rpc.msg.js.map