import * as _m0 from "protobufjs/minimal";
import { MsgCreateValidator, MsgCreateValidatorResponse, MsgEditValidator, MsgEditValidatorResponse, MsgDelegate, MsgDelegateResponse, MsgBeginRedelegate, MsgBeginRedelegateResponse, MsgUndelegate, MsgUndelegateResponse, MsgCancelUnbondingDelegation, MsgCancelUnbondingDelegationResponse, MsgUpdateParams, MsgUpdateParamsResponse } from "./tx";
export class MsgClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* CreateValidator defines a method for creating a new validator. */
    createValidator = async (request) => {
        const data = MsgCreateValidator.encode(request).finish();
        const promise = this.rpc.request("cosmos.staking.v1beta1.Msg", "CreateValidator", data);
        return promise.then(data => MsgCreateValidatorResponse.decode(new _m0.Reader(data)));
    };
    /* EditValidator defines a method for editing an existing validator. */
    editValidator = async (request) => {
        const data = MsgEditValidator.encode(request).finish();
        const promise = this.rpc.request("cosmos.staking.v1beta1.Msg", "EditValidator", data);
        return promise.then(data => MsgEditValidatorResponse.decode(new _m0.Reader(data)));
    };
    /* Delegate defines a method for performing a delegation of coins
     from a delegator to a validator. */
    delegate = async (request) => {
        const data = MsgDelegate.encode(request).finish();
        const promise = this.rpc.request("cosmos.staking.v1beta1.Msg", "Delegate", data);
        return promise.then(data => MsgDelegateResponse.decode(new _m0.Reader(data)));
    };
    /* BeginRedelegate defines a method for performing a redelegation
     of coins from a delegator and source validator to a destination validator. */
    beginRedelegate = async (request) => {
        const data = MsgBeginRedelegate.encode(request).finish();
        const promise = this.rpc.request("cosmos.staking.v1beta1.Msg", "BeginRedelegate", data);
        return promise.then(data => MsgBeginRedelegateResponse.decode(new _m0.Reader(data)));
    };
    /* Undelegate defines a method for performing an undelegation from a
     delegate and a validator. */
    undelegate = async (request) => {
        const data = MsgUndelegate.encode(request).finish();
        const promise = this.rpc.request("cosmos.staking.v1beta1.Msg", "Undelegate", data);
        return promise.then(data => MsgUndelegateResponse.decode(new _m0.Reader(data)));
    };
    /* CancelUnbondingDelegation defines a method for performing canceling the unbonding delegation
     and delegate back to previous validator.
    
     Since: cosmos-sdk 0.46 */
    cancelUnbondingDelegation = async (request) => {
        const data = MsgCancelUnbondingDelegation.encode(request).finish();
        const promise = this.rpc.request("cosmos.staking.v1beta1.Msg", "CancelUnbondingDelegation", data);
        return promise.then(data => MsgCancelUnbondingDelegationResponse.decode(new _m0.Reader(data)));
    };
    /* UpdateParams defines an operation for updating the x/staking module
     parameters.
     Since: cosmos-sdk 0.47 */
    updateParams = async (request) => {
        const data = MsgUpdateParams.encode(request).finish();
        const promise = this.rpc.request("cosmos.staking.v1beta1.Msg", "UpdateParams", data);
        return promise.then(data => MsgUpdateParamsResponse.decode(new _m0.Reader(data)));
    };
}
//# sourceMappingURL=tx.rpc.msg.js.map