import * as _m0 from "protobufjs/minimal";
import { MsgSoftwareUpgrade, MsgSoftwareUpgradeResponse, MsgCancelUpgrade, MsgCancelUpgradeResponse } from "./tx";
export class MsgClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* SoftwareUpgrade is a governance operation for initiating a software upgrade.
    
     Since: cosmos-sdk 0.46 */
    softwareUpgrade = async (request) => {
        const data = MsgSoftwareUpgrade.encode(request).finish();
        const promise = this.rpc.request("cosmos.upgrade.v1beta1.Msg", "SoftwareUpgrade", data);
        return promise.then(data => MsgSoftwareUpgradeResponse.decode(new _m0.Reader(data)));
    };
    /* CancelUpgrade is a governance operation for cancelling a previously
     approved software upgrade.
    
     Since: cosmos-sdk 0.46 */
    cancelUpgrade = async (request) => {
        const data = MsgCancelUpgrade.encode(request).finish();
        const promise = this.rpc.request("cosmos.upgrade.v1beta1.Msg", "CancelUpgrade", data);
        return promise.then(data => MsgCancelUpgradeResponse.decode(new _m0.Reader(data)));
    };
}
//# sourceMappingURL=tx.rpc.msg.js.map