"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LCDQueryClient = void 0;
class LCDQueryClient {
    req;
    constructor({ requestClient }) {
        this.req = requestClient;
    }
    /* InterchainAccount returns the interchain account address for a given owner address on a given connection */
    interchainAccount = async (params) => {
        const endpoint = `ibc/apps/interchain_accounts/controller/v1/owners/${params.owner}/connections/${params.connectionId}`;
        return await this.req.get(endpoint);
    };
    /* Params queries all parameters of the ICA controller submodule. */
    params = async (_params = {}) => {
        const endpoint = `ibc/apps/interchain_accounts/controller/v1/params`;
        return await this.req.get(endpoint);
    };
}
exports.LCDQueryClient = LCDQueryClient;
//# sourceMappingURL=query.lcd.js.map