import * as _m0 from "protobufjs/minimal";
import { MsgChannelOpenInit, MsgChannelOpenInitResponse, MsgChannelOpenTry, MsgChannelOpenTryResponse, MsgChannelOpenAck, MsgChannelOpenAckResponse, MsgChannelOpenConfirm, MsgChannelOpenConfirmResponse, MsgChannelCloseInit, MsgChannelCloseInitResponse, MsgChannelCloseConfirm, MsgChannelCloseConfirmResponse, MsgRecvPacket, MsgRecvPacketResponse, MsgTimeout, MsgTimeoutResponse, MsgTimeoutOnClose, MsgTimeoutOnCloseResponse, MsgAcknowledgement, MsgAcknowledgementResponse } from "./tx";
export class MsgClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* ChannelOpenInit defines a rpc handler method for MsgChannelOpenInit. */
    channelOpenInit = async (request) => {
        const data = MsgChannelOpenInit.encode(request).finish();
        const promise = this.rpc.request("ibc.core.channel.v1.Msg", "ChannelOpenInit", data);
        return promise.then(data => MsgChannelOpenInitResponse.decode(new _m0.Reader(data)));
    };
    /* ChannelOpenTry defines a rpc handler method for MsgChannelOpenTry. */
    channelOpenTry = async (request) => {
        const data = MsgChannelOpenTry.encode(request).finish();
        const promise = this.rpc.request("ibc.core.channel.v1.Msg", "ChannelOpenTry", data);
        return promise.then(data => MsgChannelOpenTryResponse.decode(new _m0.Reader(data)));
    };
    /* ChannelOpenAck defines a rpc handler method for MsgChannelOpenAck. */
    channelOpenAck = async (request) => {
        const data = MsgChannelOpenAck.encode(request).finish();
        const promise = this.rpc.request("ibc.core.channel.v1.Msg", "ChannelOpenAck", data);
        return promise.then(data => MsgChannelOpenAckResponse.decode(new _m0.Reader(data)));
    };
    /* ChannelOpenConfirm defines a rpc handler method for MsgChannelOpenConfirm. */
    channelOpenConfirm = async (request) => {
        const data = MsgChannelOpenConfirm.encode(request).finish();
        const promise = this.rpc.request("ibc.core.channel.v1.Msg", "ChannelOpenConfirm", data);
        return promise.then(data => MsgChannelOpenConfirmResponse.decode(new _m0.Reader(data)));
    };
    /* ChannelCloseInit defines a rpc handler method for MsgChannelCloseInit. */
    channelCloseInit = async (request) => {
        const data = MsgChannelCloseInit.encode(request).finish();
        const promise = this.rpc.request("ibc.core.channel.v1.Msg", "ChannelCloseInit", data);
        return promise.then(data => MsgChannelCloseInitResponse.decode(new _m0.Reader(data)));
    };
    /* ChannelCloseConfirm defines a rpc handler method for
     MsgChannelCloseConfirm. */
    channelCloseConfirm = async (request) => {
        const data = MsgChannelCloseConfirm.encode(request).finish();
        const promise = this.rpc.request("ibc.core.channel.v1.Msg", "ChannelCloseConfirm", data);
        return promise.then(data => MsgChannelCloseConfirmResponse.decode(new _m0.Reader(data)));
    };
    /* RecvPacket defines a rpc handler method for MsgRecvPacket. */
    recvPacket = async (request) => {
        const data = MsgRecvPacket.encode(request).finish();
        const promise = this.rpc.request("ibc.core.channel.v1.Msg", "RecvPacket", data);
        return promise.then(data => MsgRecvPacketResponse.decode(new _m0.Reader(data)));
    };
    /* Timeout defines a rpc handler method for MsgTimeout. */
    timeout = async (request) => {
        const data = MsgTimeout.encode(request).finish();
        const promise = this.rpc.request("ibc.core.channel.v1.Msg", "Timeout", data);
        return promise.then(data => MsgTimeoutResponse.decode(new _m0.Reader(data)));
    };
    /* TimeoutOnClose defines a rpc handler method for MsgTimeoutOnClose. */
    timeoutOnClose = async (request) => {
        const data = MsgTimeoutOnClose.encode(request).finish();
        const promise = this.rpc.request("ibc.core.channel.v1.Msg", "TimeoutOnClose", data);
        return promise.then(data => MsgTimeoutOnCloseResponse.decode(new _m0.Reader(data)));
    };
    /* Acknowledgement defines a rpc handler method for MsgAcknowledgement. */
    acknowledgement = async (request) => {
        const data = MsgAcknowledgement.encode(request).finish();
        const promise = this.rpc.request("ibc.core.channel.v1.Msg", "Acknowledgement", data);
        return promise.then(data => MsgAcknowledgementResponse.decode(new _m0.Reader(data)));
    };
}
//# sourceMappingURL=tx.rpc.msg.js.map