import { Rpc } from "../../../../helpers";
import { MsgCreateClient, MsgCreateClientResponse, MsgUpdateClient, MsgUpdateClientResponse, MsgUpgradeClient, MsgUpgradeClientResponse, MsgSubmitMisbehaviour, MsgSubmitMisbehaviourResponse, MsgUpdateParams, MsgUpdateParamsResponse } from "./tx";
/** Msg defines the ibc/client Msg service. */
export interface Msg {
    /** CreateClient defines a rpc handler method for MsgCreateClient. */
    createClient(request: MsgCreateClient): Promise<MsgCreateClientResponse>;
    /** UpdateClient defines a rpc handler method for MsgUpdateClient. */
    updateClient(request: MsgUpdateClient): Promise<MsgUpdateClientResponse>;
    /** UpgradeClient defines a rpc handler method for MsgUpgradeClient. */
    upgradeClient(request: MsgUpgradeClient): Promise<MsgUpgradeClientResponse>;
    /** SubmitMisbehaviour defines a rpc handler method for MsgSubmitMisbehaviour. */
    submitMisbehaviour(request: MsgSubmitMisbehaviour): Promise<MsgSubmitMisbehaviourResponse>;
    /** UpdateClientParams defines a rpc handler method for MsgUpdateParams. */
    updateClientParams(request: MsgUpdateParams): Promise<MsgUpdateParamsResponse>;
}
export declare class MsgClientImpl implements Msg {
    private readonly rpc;
    constructor(rpc: Rpc);
    createClient: (request: MsgCreateClient) => Promise<MsgCreateClientResponse>;
    updateClient: (request: MsgUpdateClient) => Promise<MsgUpdateClientResponse>;
    upgradeClient: (request: MsgUpgradeClient) => Promise<MsgUpgradeClientResponse>;
    submitMisbehaviour: (request: MsgSubmitMisbehaviour) => Promise<MsgSubmitMisbehaviourResponse>;
    updateClientParams: (request: MsgUpdateParams) => Promise<MsgUpdateParamsResponse>;
}
