import * as _m0 from "protobufjs/minimal";
import { MsgCreateClient, MsgCreateClientResponse, MsgUpdateClient, MsgUpdateClientResponse, MsgUpgradeClient, MsgUpgradeClientResponse, MsgSubmitMisbehaviour, MsgSubmitMisbehaviourResponse, MsgUpdateParams, MsgUpdateParamsResponse } from "./tx";
export class MsgClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* CreateClient defines a rpc handler method for MsgCreateClient. */
    createClient = async (request) => {
        const data = MsgCreateClient.encode(request).finish();
        const promise = this.rpc.request("ibc.core.client.v1.Msg", "CreateClient", data);
        return promise.then(data => MsgCreateClientResponse.decode(new _m0.Reader(data)));
    };
    /* UpdateClient defines a rpc handler method for MsgUpdateClient. */
    updateClient = async (request) => {
        const data = MsgUpdateClient.encode(request).finish();
        const promise = this.rpc.request("ibc.core.client.v1.Msg", "UpdateClient", data);
        return promise.then(data => MsgUpdateClientResponse.decode(new _m0.Reader(data)));
    };
    /* UpgradeClient defines a rpc handler method for MsgUpgradeClient. */
    upgradeClient = async (request) => {
        const data = MsgUpgradeClient.encode(request).finish();
        const promise = this.rpc.request("ibc.core.client.v1.Msg", "UpgradeClient", data);
        return promise.then(data => MsgUpgradeClientResponse.decode(new _m0.Reader(data)));
    };
    /* SubmitMisbehaviour defines a rpc handler method for MsgSubmitMisbehaviour. */
    submitMisbehaviour = async (request) => {
        const data = MsgSubmitMisbehaviour.encode(request).finish();
        const promise = this.rpc.request("ibc.core.client.v1.Msg", "SubmitMisbehaviour", data);
        return promise.then(data => MsgSubmitMisbehaviourResponse.decode(new _m0.Reader(data)));
    };
    /* UpdateClientParams defines a rpc handler method for MsgUpdateParams. */
    updateClientParams = async (request) => {
        const data = MsgUpdateParams.encode(request).finish();
        const promise = this.rpc.request("ibc.core.client.v1.Msg", "UpdateClientParams", data);
        return promise.then(data => MsgUpdateParamsResponse.decode(new _m0.Reader(data)));
    };
}
//# sourceMappingURL=tx.rpc.msg.js.map