/// <reference types="long" />
import * as _98 from "./abci/types";
import * as _99 from "./crypto/keys";
import * as _100 from "./crypto/proof";
import * as _101 from "./libs/bits/types";
import * as _102 from "./p2p/types";
import * as _103 from "./types/block";
import * as _104 from "./types/evidence";
import * as _105 from "./types/params";
import * as _106 from "./types/types";
import * as _107 from "./types/validator";
import * as _108 from "./version/types";
export declare namespace tendermint {
    const abci: {
        checkTxTypeFromJSON(object: any): _98.CheckTxType;
        checkTxTypeToJSON(object: _98.CheckTxType): string;
        responseOfferSnapshot_ResultFromJSON(object: any): _98.ResponseOfferSnapshot_Result;
        responseOfferSnapshot_ResultToJSON(object: _98.ResponseOfferSnapshot_Result): string;
        responseApplySnapshotChunk_ResultFromJSON(object: any): _98.ResponseApplySnapshotChunk_Result;
        responseApplySnapshotChunk_ResultToJSON(object: _98.ResponseApplySnapshotChunk_Result): string;
        responseProcessProposal_ProposalStatusFromJSON(object: any): _98.ResponseProcessProposal_ProposalStatus;
        responseProcessProposal_ProposalStatusToJSON(object: _98.ResponseProcessProposal_ProposalStatus): string;
        responseVerifyVoteExtension_VerifyStatusFromJSON(object: any): _98.ResponseVerifyVoteExtension_VerifyStatus;
        responseVerifyVoteExtension_VerifyStatusToJSON(object: _98.ResponseVerifyVoteExtension_VerifyStatus): string;
        misbehaviorTypeFromJSON(object: any): _98.MisbehaviorType;
        misbehaviorTypeToJSON(object: _98.MisbehaviorType): string;
        CheckTxType: typeof _98.CheckTxType;
        CheckTxTypeSDKType: typeof _98.CheckTxType;
        CheckTxTypeAmino: typeof _98.CheckTxType;
        ResponseOfferSnapshot_Result: typeof _98.ResponseOfferSnapshot_Result;
        ResponseOfferSnapshot_ResultSDKType: typeof _98.ResponseOfferSnapshot_Result;
        ResponseOfferSnapshot_ResultAmino: typeof _98.ResponseOfferSnapshot_Result;
        ResponseApplySnapshotChunk_Result: typeof _98.ResponseApplySnapshotChunk_Result;
        ResponseApplySnapshotChunk_ResultSDKType: typeof _98.ResponseApplySnapshotChunk_Result;
        ResponseApplySnapshotChunk_ResultAmino: typeof _98.ResponseApplySnapshotChunk_Result;
        ResponseProcessProposal_ProposalStatus: typeof _98.ResponseProcessProposal_ProposalStatus;
        ResponseProcessProposal_ProposalStatusSDKType: typeof _98.ResponseProcessProposal_ProposalStatus;
        ResponseProcessProposal_ProposalStatusAmino: typeof _98.ResponseProcessProposal_ProposalStatus;
        ResponseVerifyVoteExtension_VerifyStatus: typeof _98.ResponseVerifyVoteExtension_VerifyStatus;
        ResponseVerifyVoteExtension_VerifyStatusSDKType: typeof _98.ResponseVerifyVoteExtension_VerifyStatus;
        ResponseVerifyVoteExtension_VerifyStatusAmino: typeof _98.ResponseVerifyVoteExtension_VerifyStatus;
        MisbehaviorType: typeof _98.MisbehaviorType;
        MisbehaviorTypeSDKType: typeof _98.MisbehaviorType;
        MisbehaviorTypeAmino: typeof _98.MisbehaviorType;
        Request: {
            typeUrl: string;
            encode(message: _98.Request, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.Request;
            fromPartial(object: {
                echo?: {
                    message?: string;
                };
                flush?: {};
                info?: {
                    version?: string;
                    blockVersion?: string | number | import("long").Long;
                    p2pVersion?: string | number | import("long").Long;
                    abciVersion?: string;
                };
                initChain?: {
                    time?: Date;
                    chainId?: string;
                    consensusParams?: {
                        block?: {
                            maxBytes?: string | number | import("long").Long;
                            maxGas?: string | number | import("long").Long;
                        };
                        evidence?: {
                            maxAgeNumBlocks?: string | number | import("long").Long;
                            maxAgeDuration?: {
                                seconds?: string | number | import("long").Long;
                                nanos?: number;
                            };
                            maxBytes?: string | number | import("long").Long;
                        };
                        validator?: {
                            pubKeyTypes?: string[];
                        };
                        version?: {
                            app?: string | number | import("long").Long;
                        };
                        abci?: {
                            voteExtensionsEnableHeight?: string | number | import("long").Long;
                        };
                    };
                    validators?: {
                        pubKey?: {
                            ed25519?: Uint8Array;
                            secp256k1?: Uint8Array;
                        };
                        power?: string | number | import("long").Long;
                    }[];
                    appStateBytes?: Uint8Array;
                    initialHeight?: string | number | import("long").Long;
                };
                query?: {
                    data?: Uint8Array;
                    path?: string;
                    height?: string | number | import("long").Long;
                    prove?: boolean;
                };
                checkTx?: {
                    tx?: Uint8Array;
                    type?: _98.CheckTxType;
                };
                commit?: {};
                listSnapshots?: {};
                offerSnapshot?: {
                    snapshot?: {
                        height?: string | number | import("long").Long;
                        format?: number;
                        chunks?: number;
                        hash?: Uint8Array;
                        metadata?: Uint8Array;
                    };
                    appHash?: Uint8Array;
                };
                loadSnapshotChunk?: {
                    height?: string | number | import("long").Long;
                    format?: number;
                    chunk?: number;
                };
                applySnapshotChunk?: {
                    index?: number;
                    chunk?: Uint8Array;
                    sender?: string;
                };
                prepareProposal?: {
                    maxTxBytes?: string | number | import("long").Long;
                    txs?: Uint8Array[];
                    localLastCommit?: {
                        round?: number;
                        votes?: {
                            validator?: {
                                address?: Uint8Array;
                                power?: string | number | import("long").Long;
                            };
                            voteExtension?: Uint8Array;
                            extensionSignature?: Uint8Array;
                            blockIdFlag?: _107.BlockIDFlag;
                        }[];
                    };
                    misbehavior?: {
                        type?: _98.MisbehaviorType;
                        validator?: {
                            address?: Uint8Array;
                            power?: string | number | import("long").Long;
                        };
                        height?: string | number | import("long").Long;
                        time?: Date;
                        totalVotingPower?: string | number | import("long").Long;
                    }[];
                    height?: string | number | import("long").Long;
                    time?: Date;
                    nextValidatorsHash?: Uint8Array;
                    proposerAddress?: Uint8Array;
                };
                processProposal?: {
                    txs?: Uint8Array[];
                    proposedLastCommit?: {
                        round?: number;
                        votes?: {
                            validator?: {
                                address?: Uint8Array;
                                power?: string | number | import("long").Long;
                            };
                            blockIdFlag?: _107.BlockIDFlag;
                        }[];
                    };
                    misbehavior?: {
                        type?: _98.MisbehaviorType;
                        validator?: {
                            address?: Uint8Array;
                            power?: string | number | import("long").Long;
                        };
                        height?: string | number | import("long").Long;
                        time?: Date;
                        totalVotingPower?: string | number | import("long").Long;
                    }[];
                    hash?: Uint8Array;
                    height?: string | number | import("long").Long;
                    time?: Date;
                    nextValidatorsHash?: Uint8Array;
                    proposerAddress?: Uint8Array;
                };
                extendVote?: {
                    hash?: Uint8Array;
                    height?: string | number | import("long").Long;
                };
                verifyVoteExtension?: {
                    hash?: Uint8Array;
                    validatorAddress?: Uint8Array;
                    height?: string | number | import("long").Long;
                    voteExtension?: Uint8Array;
                };
                finalizeBlock?: {
                    txs?: Uint8Array[];
                    decidedLastCommit?: {
                        round?: number;
                        votes?: {
                            validator?: {
                                address?: Uint8Array;
                                power?: string | number | import("long").Long;
                            };
                            blockIdFlag?: _107.BlockIDFlag;
                        }[];
                    };
                    misbehavior?: {
                        type?: _98.MisbehaviorType;
                        validator?: {
                            address?: Uint8Array;
                            power?: string | number | import("long").Long;
                        };
                        height?: string | number | import("long").Long;
                        time?: Date;
                        totalVotingPower?: string | number | import("long").Long;
                    }[];
                    hash?: Uint8Array;
                    height?: string | number | import("long").Long;
                    time?: Date;
                    nextValidatorsHash?: Uint8Array;
                    proposerAddress?: Uint8Array;
                };
            }): _98.Request;
            fromAmino(object: _98.RequestAmino): _98.Request;
            toAmino(message: _98.Request): _98.RequestAmino;
            fromAminoMsg(object: _98.RequestAminoMsg): _98.Request;
            fromProtoMsg(message: _98.RequestProtoMsg): _98.Request;
            toProto(message: _98.Request): Uint8Array;
            toProtoMsg(message: _98.Request): _98.RequestProtoMsg;
        };
        RequestEcho: {
            typeUrl: string;
            encode(message: _98.RequestEcho, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.RequestEcho;
            fromPartial(object: {
                message?: string;
            }): _98.RequestEcho;
            fromAmino(object: _98.RequestEchoAmino): _98.RequestEcho;
            toAmino(message: _98.RequestEcho): _98.RequestEchoAmino;
            fromAminoMsg(object: _98.RequestEchoAminoMsg): _98.RequestEcho;
            fromProtoMsg(message: _98.RequestEchoProtoMsg): _98.RequestEcho;
            toProto(message: _98.RequestEcho): Uint8Array;
            toProtoMsg(message: _98.RequestEcho): _98.RequestEchoProtoMsg;
        };
        RequestFlush: {
            typeUrl: string;
            encode(_: _98.RequestFlush, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.RequestFlush;
            fromPartial(_: {}): _98.RequestFlush;
            fromAmino(_: _98.RequestFlushAmino): _98.RequestFlush;
            toAmino(_: _98.RequestFlush): _98.RequestFlushAmino;
            fromAminoMsg(object: _98.RequestFlushAminoMsg): _98.RequestFlush;
            fromProtoMsg(message: _98.RequestFlushProtoMsg): _98.RequestFlush;
            toProto(message: _98.RequestFlush): Uint8Array;
            toProtoMsg(message: _98.RequestFlush): _98.RequestFlushProtoMsg;
        };
        RequestInfo: {
            typeUrl: string;
            encode(message: _98.RequestInfo, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.RequestInfo;
            fromPartial(object: {
                version?: string;
                blockVersion?: string | number | import("long").Long;
                p2pVersion?: string | number | import("long").Long;
                abciVersion?: string;
            }): _98.RequestInfo;
            fromAmino(object: _98.RequestInfoAmino): _98.RequestInfo;
            toAmino(message: _98.RequestInfo): _98.RequestInfoAmino;
            fromAminoMsg(object: _98.RequestInfoAminoMsg): _98.RequestInfo;
            fromProtoMsg(message: _98.RequestInfoProtoMsg): _98.RequestInfo;
            toProto(message: _98.RequestInfo): Uint8Array;
            toProtoMsg(message: _98.RequestInfo): _98.RequestInfoProtoMsg;
        };
        RequestInitChain: {
            typeUrl: string;
            encode(message: _98.RequestInitChain, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.RequestInitChain;
            fromPartial(object: {
                time?: Date;
                chainId?: string;
                consensusParams?: {
                    block?: {
                        maxBytes?: string | number | import("long").Long;
                        maxGas?: string | number | import("long").Long;
                    };
                    evidence?: {
                        maxAgeNumBlocks?: string | number | import("long").Long;
                        maxAgeDuration?: {
                            seconds?: string | number | import("long").Long;
                            nanos?: number;
                        };
                        maxBytes?: string | number | import("long").Long;
                    };
                    validator?: {
                        pubKeyTypes?: string[];
                    };
                    version?: {
                        app?: string | number | import("long").Long;
                    };
                    abci?: {
                        voteExtensionsEnableHeight?: string | number | import("long").Long;
                    };
                };
                validators?: {
                    pubKey?: {
                        ed25519?: Uint8Array;
                        secp256k1?: Uint8Array;
                    };
                    power?: string | number | import("long").Long;
                }[];
                appStateBytes?: Uint8Array;
                initialHeight?: string | number | import("long").Long;
            }): _98.RequestInitChain;
            fromAmino(object: _98.RequestInitChainAmino): _98.RequestInitChain;
            toAmino(message: _98.RequestInitChain): _98.RequestInitChainAmino;
            fromAminoMsg(object: _98.RequestInitChainAminoMsg): _98.RequestInitChain;
            fromProtoMsg(message: _98.RequestInitChainProtoMsg): _98.RequestInitChain;
            toProto(message: _98.RequestInitChain): Uint8Array;
            toProtoMsg(message: _98.RequestInitChain): _98.RequestInitChainProtoMsg;
        };
        RequestQuery: {
            typeUrl: string;
            encode(message: _98.RequestQuery, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.RequestQuery;
            fromPartial(object: {
                data?: Uint8Array;
                path?: string;
                height?: string | number | import("long").Long;
                prove?: boolean;
            }): _98.RequestQuery;
            fromAmino(object: _98.RequestQueryAmino): _98.RequestQuery;
            toAmino(message: _98.RequestQuery): _98.RequestQueryAmino;
            fromAminoMsg(object: _98.RequestQueryAminoMsg): _98.RequestQuery;
            fromProtoMsg(message: _98.RequestQueryProtoMsg): _98.RequestQuery;
            toProto(message: _98.RequestQuery): Uint8Array;
            toProtoMsg(message: _98.RequestQuery): _98.RequestQueryProtoMsg;
        };
        RequestCheckTx: {
            typeUrl: string;
            encode(message: _98.RequestCheckTx, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.RequestCheckTx;
            fromPartial(object: {
                tx?: Uint8Array;
                type?: _98.CheckTxType;
            }): _98.RequestCheckTx;
            fromAmino(object: _98.RequestCheckTxAmino): _98.RequestCheckTx;
            toAmino(message: _98.RequestCheckTx): _98.RequestCheckTxAmino;
            fromAminoMsg(object: _98.RequestCheckTxAminoMsg): _98.RequestCheckTx;
            fromProtoMsg(message: _98.RequestCheckTxProtoMsg): _98.RequestCheckTx;
            toProto(message: _98.RequestCheckTx): Uint8Array;
            toProtoMsg(message: _98.RequestCheckTx): _98.RequestCheckTxProtoMsg;
        };
        RequestCommit: {
            typeUrl: string;
            encode(_: _98.RequestCommit, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.RequestCommit;
            fromPartial(_: {}): _98.RequestCommit;
            fromAmino(_: _98.RequestCommitAmino): _98.RequestCommit;
            toAmino(_: _98.RequestCommit): _98.RequestCommitAmino;
            fromAminoMsg(object: _98.RequestCommitAminoMsg): _98.RequestCommit;
            fromProtoMsg(message: _98.RequestCommitProtoMsg): _98.RequestCommit;
            toProto(message: _98.RequestCommit): Uint8Array;
            toProtoMsg(message: _98.RequestCommit): _98.RequestCommitProtoMsg;
        };
        RequestListSnapshots: {
            typeUrl: string;
            encode(_: _98.RequestListSnapshots, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.RequestListSnapshots;
            fromPartial(_: {}): _98.RequestListSnapshots;
            fromAmino(_: _98.RequestListSnapshotsAmino): _98.RequestListSnapshots;
            toAmino(_: _98.RequestListSnapshots): _98.RequestListSnapshotsAmino;
            fromAminoMsg(object: _98.RequestListSnapshotsAminoMsg): _98.RequestListSnapshots;
            fromProtoMsg(message: _98.RequestListSnapshotsProtoMsg): _98.RequestListSnapshots;
            toProto(message: _98.RequestListSnapshots): Uint8Array;
            toProtoMsg(message: _98.RequestListSnapshots): _98.RequestListSnapshotsProtoMsg;
        };
        RequestOfferSnapshot: {
            typeUrl: string;
            encode(message: _98.RequestOfferSnapshot, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.RequestOfferSnapshot;
            fromPartial(object: {
                snapshot?: {
                    height?: string | number | import("long").Long;
                    format?: number;
                    chunks?: number;
                    hash?: Uint8Array;
                    metadata?: Uint8Array;
                };
                appHash?: Uint8Array;
            }): _98.RequestOfferSnapshot;
            fromAmino(object: _98.RequestOfferSnapshotAmino): _98.RequestOfferSnapshot;
            toAmino(message: _98.RequestOfferSnapshot): _98.RequestOfferSnapshotAmino;
            fromAminoMsg(object: _98.RequestOfferSnapshotAminoMsg): _98.RequestOfferSnapshot;
            fromProtoMsg(message: _98.RequestOfferSnapshotProtoMsg): _98.RequestOfferSnapshot;
            toProto(message: _98.RequestOfferSnapshot): Uint8Array;
            toProtoMsg(message: _98.RequestOfferSnapshot): _98.RequestOfferSnapshotProtoMsg;
        };
        RequestLoadSnapshotChunk: {
            typeUrl: string;
            encode(message: _98.RequestLoadSnapshotChunk, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.RequestLoadSnapshotChunk;
            fromPartial(object: {
                height?: string | number | import("long").Long;
                format?: number;
                chunk?: number;
            }): _98.RequestLoadSnapshotChunk;
            fromAmino(object: _98.RequestLoadSnapshotChunkAmino): _98.RequestLoadSnapshotChunk;
            toAmino(message: _98.RequestLoadSnapshotChunk): _98.RequestLoadSnapshotChunkAmino;
            fromAminoMsg(object: _98.RequestLoadSnapshotChunkAminoMsg): _98.RequestLoadSnapshotChunk;
            fromProtoMsg(message: _98.RequestLoadSnapshotChunkProtoMsg): _98.RequestLoadSnapshotChunk;
            toProto(message: _98.RequestLoadSnapshotChunk): Uint8Array;
            toProtoMsg(message: _98.RequestLoadSnapshotChunk): _98.RequestLoadSnapshotChunkProtoMsg;
        };
        RequestApplySnapshotChunk: {
            typeUrl: string;
            encode(message: _98.RequestApplySnapshotChunk, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.RequestApplySnapshotChunk;
            fromPartial(object: {
                index?: number;
                chunk?: Uint8Array;
                sender?: string;
            }): _98.RequestApplySnapshotChunk;
            fromAmino(object: _98.RequestApplySnapshotChunkAmino): _98.RequestApplySnapshotChunk;
            toAmino(message: _98.RequestApplySnapshotChunk): _98.RequestApplySnapshotChunkAmino;
            fromAminoMsg(object: _98.RequestApplySnapshotChunkAminoMsg): _98.RequestApplySnapshotChunk;
            fromProtoMsg(message: _98.RequestApplySnapshotChunkProtoMsg): _98.RequestApplySnapshotChunk;
            toProto(message: _98.RequestApplySnapshotChunk): Uint8Array;
            toProtoMsg(message: _98.RequestApplySnapshotChunk): _98.RequestApplySnapshotChunkProtoMsg;
        };
        RequestPrepareProposal: {
            typeUrl: string;
            encode(message: _98.RequestPrepareProposal, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.RequestPrepareProposal;
            fromPartial(object: {
                maxTxBytes?: string | number | import("long").Long;
                txs?: Uint8Array[];
                localLastCommit?: {
                    round?: number;
                    votes?: {
                        validator?: {
                            address?: Uint8Array;
                            power?: string | number | import("long").Long;
                        };
                        voteExtension?: Uint8Array;
                        extensionSignature?: Uint8Array;
                        blockIdFlag?: _107.BlockIDFlag;
                    }[];
                };
                misbehavior?: {
                    type?: _98.MisbehaviorType;
                    validator?: {
                        address?: Uint8Array;
                        power?: string | number | import("long").Long;
                    };
                    height?: string | number | import("long").Long;
                    time?: Date;
                    totalVotingPower?: string | number | import("long").Long;
                }[];
                height?: string | number | import("long").Long;
                time?: Date;
                nextValidatorsHash?: Uint8Array;
                proposerAddress?: Uint8Array;
            }): _98.RequestPrepareProposal;
            fromAmino(object: _98.RequestPrepareProposalAmino): _98.RequestPrepareProposal;
            toAmino(message: _98.RequestPrepareProposal): _98.RequestPrepareProposalAmino;
            fromAminoMsg(object: _98.RequestPrepareProposalAminoMsg): _98.RequestPrepareProposal;
            fromProtoMsg(message: _98.RequestPrepareProposalProtoMsg): _98.RequestPrepareProposal;
            toProto(message: _98.RequestPrepareProposal): Uint8Array;
            toProtoMsg(message: _98.RequestPrepareProposal): _98.RequestPrepareProposalProtoMsg;
        };
        RequestProcessProposal: {
            typeUrl: string;
            encode(message: _98.RequestProcessProposal, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.RequestProcessProposal;
            fromPartial(object: {
                txs?: Uint8Array[];
                proposedLastCommit?: {
                    round?: number;
                    votes?: {
                        validator?: {
                            address?: Uint8Array;
                            power?: string | number | import("long").Long;
                        };
                        blockIdFlag?: _107.BlockIDFlag;
                    }[];
                };
                misbehavior?: {
                    type?: _98.MisbehaviorType;
                    validator?: {
                        address?: Uint8Array;
                        power?: string | number | import("long").Long;
                    };
                    height?: string | number | import("long").Long;
                    time?: Date;
                    totalVotingPower?: string | number | import("long").Long;
                }[];
                hash?: Uint8Array;
                height?: string | number | import("long").Long;
                time?: Date;
                nextValidatorsHash?: Uint8Array;
                proposerAddress?: Uint8Array;
            }): _98.RequestProcessProposal;
            fromAmino(object: _98.RequestProcessProposalAmino): _98.RequestProcessProposal;
            toAmino(message: _98.RequestProcessProposal): _98.RequestProcessProposalAmino;
            fromAminoMsg(object: _98.RequestProcessProposalAminoMsg): _98.RequestProcessProposal;
            fromProtoMsg(message: _98.RequestProcessProposalProtoMsg): _98.RequestProcessProposal;
            toProto(message: _98.RequestProcessProposal): Uint8Array;
            toProtoMsg(message: _98.RequestProcessProposal): _98.RequestProcessProposalProtoMsg;
        };
        RequestExtendVote: {
            typeUrl: string;
            encode(message: _98.RequestExtendVote, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.RequestExtendVote;
            fromPartial(object: {
                hash?: Uint8Array;
                height?: string | number | import("long").Long;
            }): _98.RequestExtendVote;
            fromAmino(object: _98.RequestExtendVoteAmino): _98.RequestExtendVote;
            toAmino(message: _98.RequestExtendVote): _98.RequestExtendVoteAmino;
            fromAminoMsg(object: _98.RequestExtendVoteAminoMsg): _98.RequestExtendVote;
            fromProtoMsg(message: _98.RequestExtendVoteProtoMsg): _98.RequestExtendVote;
            toProto(message: _98.RequestExtendVote): Uint8Array;
            toProtoMsg(message: _98.RequestExtendVote): _98.RequestExtendVoteProtoMsg;
        };
        RequestVerifyVoteExtension: {
            typeUrl: string;
            encode(message: _98.RequestVerifyVoteExtension, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.RequestVerifyVoteExtension;
            fromPartial(object: {
                hash?: Uint8Array;
                validatorAddress?: Uint8Array;
                height?: string | number | import("long").Long;
                voteExtension?: Uint8Array;
            }): _98.RequestVerifyVoteExtension;
            fromAmino(object: _98.RequestVerifyVoteExtensionAmino): _98.RequestVerifyVoteExtension;
            toAmino(message: _98.RequestVerifyVoteExtension): _98.RequestVerifyVoteExtensionAmino;
            fromAminoMsg(object: _98.RequestVerifyVoteExtensionAminoMsg): _98.RequestVerifyVoteExtension;
            fromProtoMsg(message: _98.RequestVerifyVoteExtensionProtoMsg): _98.RequestVerifyVoteExtension;
            toProto(message: _98.RequestVerifyVoteExtension): Uint8Array;
            toProtoMsg(message: _98.RequestVerifyVoteExtension): _98.RequestVerifyVoteExtensionProtoMsg;
        };
        RequestFinalizeBlock: {
            typeUrl: string;
            encode(message: _98.RequestFinalizeBlock, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.RequestFinalizeBlock;
            fromPartial(object: {
                txs?: Uint8Array[];
                decidedLastCommit?: {
                    round?: number;
                    votes?: {
                        validator?: {
                            address?: Uint8Array;
                            power?: string | number | import("long").Long;
                        };
                        blockIdFlag?: _107.BlockIDFlag;
                    }[];
                };
                misbehavior?: {
                    type?: _98.MisbehaviorType;
                    validator?: {
                        address?: Uint8Array;
                        power?: string | number | import("long").Long;
                    };
                    height?: string | number | import("long").Long;
                    time?: Date;
                    totalVotingPower?: string | number | import("long").Long;
                }[];
                hash?: Uint8Array;
                height?: string | number | import("long").Long;
                time?: Date;
                nextValidatorsHash?: Uint8Array;
                proposerAddress?: Uint8Array;
            }): _98.RequestFinalizeBlock;
            fromAmino(object: _98.RequestFinalizeBlockAmino): _98.RequestFinalizeBlock;
            toAmino(message: _98.RequestFinalizeBlock): _98.RequestFinalizeBlockAmino;
            fromAminoMsg(object: _98.RequestFinalizeBlockAminoMsg): _98.RequestFinalizeBlock;
            fromProtoMsg(message: _98.RequestFinalizeBlockProtoMsg): _98.RequestFinalizeBlock;
            toProto(message: _98.RequestFinalizeBlock): Uint8Array;
            toProtoMsg(message: _98.RequestFinalizeBlock): _98.RequestFinalizeBlockProtoMsg;
        };
        Response: {
            typeUrl: string;
            encode(message: _98.Response, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.Response;
            fromPartial(object: {
                exception?: {
                    error?: string;
                };
                echo?: {
                    message?: string;
                };
                flush?: {};
                info?: {
                    data?: string;
                    version?: string;
                    appVersion?: string | number | import("long").Long;
                    lastBlockHeight?: string | number | import("long").Long;
                    lastBlockAppHash?: Uint8Array;
                };
                initChain?: {
                    consensusParams?: {
                        block?: {
                            maxBytes?: string | number | import("long").Long;
                            maxGas?: string | number | import("long").Long;
                        };
                        evidence?: {
                            maxAgeNumBlocks?: string | number | import("long").Long;
                            maxAgeDuration?: {
                                seconds?: string | number | import("long").Long;
                                nanos?: number;
                            };
                            maxBytes?: string | number | import("long").Long;
                        };
                        validator?: {
                            pubKeyTypes?: string[];
                        };
                        version?: {
                            app?: string | number | import("long").Long;
                        };
                        abci?: {
                            voteExtensionsEnableHeight?: string | number | import("long").Long;
                        };
                    };
                    validators?: {
                        pubKey?: {
                            ed25519?: Uint8Array;
                            secp256k1?: Uint8Array;
                        };
                        power?: string | number | import("long").Long;
                    }[];
                    appHash?: Uint8Array;
                };
                query?: {
                    code?: number;
                    log?: string;
                    info?: string;
                    index?: string | number | import("long").Long;
                    key?: Uint8Array;
                    value?: Uint8Array;
                    proofOps?: {
                        ops?: {
                            type?: string;
                            key?: Uint8Array;
                            data?: Uint8Array;
                        }[];
                    };
                    height?: string | number | import("long").Long;
                    codespace?: string;
                };
                checkTx?: {
                    code?: number;
                    data?: Uint8Array;
                    log?: string;
                    info?: string;
                    gasWanted?: string | number | import("long").Long;
                    gasUsed?: string | number | import("long").Long;
                    events?: {
                        type?: string;
                        attributes?: {
                            key?: string;
                            value?: string;
                            index?: boolean;
                        }[];
                    }[];
                    codespace?: string;
                };
                commit?: {
                    retainHeight?: string | number | import("long").Long;
                };
                listSnapshots?: {
                    snapshots?: {
                        height?: string | number | import("long").Long;
                        format?: number;
                        chunks?: number;
                        hash?: Uint8Array;
                        metadata?: Uint8Array;
                    }[];
                };
                offerSnapshot?: {
                    result?: _98.ResponseOfferSnapshot_Result;
                };
                loadSnapshotChunk?: {
                    chunk?: Uint8Array;
                };
                applySnapshotChunk?: {
                    result?: _98.ResponseApplySnapshotChunk_Result;
                    refetchChunks?: number[];
                    rejectSenders?: string[];
                };
                prepareProposal?: {
                    txs?: Uint8Array[];
                };
                processProposal?: {
                    status?: _98.ResponseProcessProposal_ProposalStatus;
                };
                extendVote?: {
                    voteExtension?: Uint8Array;
                };
                verifyVoteExtension?: {
                    status?: _98.ResponseVerifyVoteExtension_VerifyStatus;
                };
                finalizeBlock?: {
                    events?: {
                        type?: string;
                        attributes?: {
                            key?: string;
                            value?: string;
                            index?: boolean;
                        }[];
                    }[];
                    txResults?: {
                        code?: number;
                        data?: Uint8Array;
                        log?: string;
                        info?: string;
                        gasWanted?: string | number | import("long").Long;
                        gasUsed?: string | number | import("long").Long;
                        events?: {
                            type?: string;
                            attributes?: {
                                key?: string;
                                value?: string;
                                index?: boolean;
                            }[];
                        }[];
                        codespace?: string;
                    }[];
                    validatorUpdates?: {
                        pubKey?: {
                            ed25519?: Uint8Array;
                            secp256k1?: Uint8Array;
                        };
                        power?: string | number | import("long").Long;
                    }[];
                    consensusParamUpdates?: {
                        block?: {
                            maxBytes?: string | number | import("long").Long;
                            maxGas?: string | number | import("long").Long;
                        };
                        evidence?: {
                            maxAgeNumBlocks?: string | number | import("long").Long;
                            maxAgeDuration?: {
                                seconds?: string | number | import("long").Long;
                                nanos?: number;
                            };
                            maxBytes?: string | number | import("long").Long;
                        };
                        validator?: {
                            pubKeyTypes?: string[];
                        };
                        version?: {
                            app?: string | number | import("long").Long;
                        };
                        abci?: {
                            voteExtensionsEnableHeight?: string | number | import("long").Long;
                        };
                    };
                    appHash?: Uint8Array;
                };
            }): _98.Response;
            fromAmino(object: _98.ResponseAmino): _98.Response;
            toAmino(message: _98.Response): _98.ResponseAmino;
            fromAminoMsg(object: _98.ResponseAminoMsg): _98.Response;
            fromProtoMsg(message: _98.ResponseProtoMsg): _98.Response;
            toProto(message: _98.Response): Uint8Array;
            toProtoMsg(message: _98.Response): _98.ResponseProtoMsg;
        };
        ResponseException: {
            typeUrl: string;
            encode(message: _98.ResponseException, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.ResponseException;
            fromPartial(object: {
                error?: string;
            }): _98.ResponseException;
            fromAmino(object: _98.ResponseExceptionAmino): _98.ResponseException;
            toAmino(message: _98.ResponseException): _98.ResponseExceptionAmino;
            fromAminoMsg(object: _98.ResponseExceptionAminoMsg): _98.ResponseException;
            fromProtoMsg(message: _98.ResponseExceptionProtoMsg): _98.ResponseException;
            toProto(message: _98.ResponseException): Uint8Array;
            toProtoMsg(message: _98.ResponseException): _98.ResponseExceptionProtoMsg;
        };
        ResponseEcho: {
            typeUrl: string;
            encode(message: _98.ResponseEcho, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.ResponseEcho;
            fromPartial(object: {
                message?: string;
            }): _98.ResponseEcho;
            fromAmino(object: _98.ResponseEchoAmino): _98.ResponseEcho;
            toAmino(message: _98.ResponseEcho): _98.ResponseEchoAmino;
            fromAminoMsg(object: _98.ResponseEchoAminoMsg): _98.ResponseEcho;
            fromProtoMsg(message: _98.ResponseEchoProtoMsg): _98.ResponseEcho;
            toProto(message: _98.ResponseEcho): Uint8Array;
            toProtoMsg(message: _98.ResponseEcho): _98.ResponseEchoProtoMsg;
        };
        ResponseFlush: {
            typeUrl: string;
            encode(_: _98.ResponseFlush, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.ResponseFlush;
            fromPartial(_: {}): _98.ResponseFlush;
            fromAmino(_: _98.ResponseFlushAmino): _98.ResponseFlush;
            toAmino(_: _98.ResponseFlush): _98.ResponseFlushAmino;
            fromAminoMsg(object: _98.ResponseFlushAminoMsg): _98.ResponseFlush;
            fromProtoMsg(message: _98.ResponseFlushProtoMsg): _98.ResponseFlush;
            toProto(message: _98.ResponseFlush): Uint8Array;
            toProtoMsg(message: _98.ResponseFlush): _98.ResponseFlushProtoMsg;
        };
        ResponseInfo: {
            typeUrl: string;
            encode(message: _98.ResponseInfo, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.ResponseInfo;
            fromPartial(object: {
                data?: string;
                version?: string;
                appVersion?: string | number | import("long").Long;
                lastBlockHeight?: string | number | import("long").Long;
                lastBlockAppHash?: Uint8Array;
            }): _98.ResponseInfo;
            fromAmino(object: _98.ResponseInfoAmino): _98.ResponseInfo;
            toAmino(message: _98.ResponseInfo): _98.ResponseInfoAmino;
            fromAminoMsg(object: _98.ResponseInfoAminoMsg): _98.ResponseInfo;
            fromProtoMsg(message: _98.ResponseInfoProtoMsg): _98.ResponseInfo;
            toProto(message: _98.ResponseInfo): Uint8Array;
            toProtoMsg(message: _98.ResponseInfo): _98.ResponseInfoProtoMsg;
        };
        ResponseInitChain: {
            typeUrl: string;
            encode(message: _98.ResponseInitChain, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.ResponseInitChain;
            fromPartial(object: {
                consensusParams?: {
                    block?: {
                        maxBytes?: string | number | import("long").Long;
                        maxGas?: string | number | import("long").Long;
                    };
                    evidence?: {
                        maxAgeNumBlocks?: string | number | import("long").Long;
                        maxAgeDuration?: {
                            seconds?: string | number | import("long").Long;
                            nanos?: number;
                        };
                        maxBytes?: string | number | import("long").Long;
                    };
                    validator?: {
                        pubKeyTypes?: string[];
                    };
                    version?: {
                        app?: string | number | import("long").Long;
                    };
                    abci?: {
                        voteExtensionsEnableHeight?: string | number | import("long").Long;
                    };
                };
                validators?: {
                    pubKey?: {
                        ed25519?: Uint8Array;
                        secp256k1?: Uint8Array;
                    };
                    power?: string | number | import("long").Long;
                }[];
                appHash?: Uint8Array;
            }): _98.ResponseInitChain;
            fromAmino(object: _98.ResponseInitChainAmino): _98.ResponseInitChain;
            toAmino(message: _98.ResponseInitChain): _98.ResponseInitChainAmino;
            fromAminoMsg(object: _98.ResponseInitChainAminoMsg): _98.ResponseInitChain;
            fromProtoMsg(message: _98.ResponseInitChainProtoMsg): _98.ResponseInitChain;
            toProto(message: _98.ResponseInitChain): Uint8Array;
            toProtoMsg(message: _98.ResponseInitChain): _98.ResponseInitChainProtoMsg;
        };
        ResponseQuery: {
            typeUrl: string;
            encode(message: _98.ResponseQuery, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.ResponseQuery;
            fromPartial(object: {
                code?: number;
                log?: string;
                info?: string;
                index?: string | number | import("long").Long;
                key?: Uint8Array;
                value?: Uint8Array;
                proofOps?: {
                    ops?: {
                        type?: string;
                        key?: Uint8Array;
                        data?: Uint8Array;
                    }[];
                };
                height?: string | number | import("long").Long;
                codespace?: string;
            }): _98.ResponseQuery;
            fromAmino(object: _98.ResponseQueryAmino): _98.ResponseQuery;
            toAmino(message: _98.ResponseQuery): _98.ResponseQueryAmino;
            fromAminoMsg(object: _98.ResponseQueryAminoMsg): _98.ResponseQuery;
            fromProtoMsg(message: _98.ResponseQueryProtoMsg): _98.ResponseQuery;
            toProto(message: _98.ResponseQuery): Uint8Array;
            toProtoMsg(message: _98.ResponseQuery): _98.ResponseQueryProtoMsg;
        };
        ResponseCheckTx: {
            typeUrl: string;
            encode(message: _98.ResponseCheckTx, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.ResponseCheckTx;
            fromPartial(object: {
                code?: number;
                data?: Uint8Array;
                log?: string;
                info?: string;
                gasWanted?: string | number | import("long").Long;
                gasUsed?: string | number | import("long").Long;
                events?: {
                    type?: string;
                    attributes?: {
                        key?: string;
                        value?: string;
                        index?: boolean;
                    }[];
                }[];
                codespace?: string;
            }): _98.ResponseCheckTx;
            fromAmino(object: _98.ResponseCheckTxAmino): _98.ResponseCheckTx;
            toAmino(message: _98.ResponseCheckTx): _98.ResponseCheckTxAmino;
            fromAminoMsg(object: _98.ResponseCheckTxAminoMsg): _98.ResponseCheckTx;
            fromProtoMsg(message: _98.ResponseCheckTxProtoMsg): _98.ResponseCheckTx;
            toProto(message: _98.ResponseCheckTx): Uint8Array;
            toProtoMsg(message: _98.ResponseCheckTx): _98.ResponseCheckTxProtoMsg;
        };
        ResponseCommit: {
            typeUrl: string;
            encode(message: _98.ResponseCommit, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.ResponseCommit;
            fromPartial(object: {
                retainHeight?: string | number | import("long").Long;
            }): _98.ResponseCommit;
            fromAmino(object: _98.ResponseCommitAmino): _98.ResponseCommit;
            toAmino(message: _98.ResponseCommit): _98.ResponseCommitAmino;
            fromAminoMsg(object: _98.ResponseCommitAminoMsg): _98.ResponseCommit;
            fromProtoMsg(message: _98.ResponseCommitProtoMsg): _98.ResponseCommit;
            toProto(message: _98.ResponseCommit): Uint8Array;
            toProtoMsg(message: _98.ResponseCommit): _98.ResponseCommitProtoMsg;
        };
        ResponseListSnapshots: {
            typeUrl: string;
            encode(message: _98.ResponseListSnapshots, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.ResponseListSnapshots;
            fromPartial(object: {
                snapshots?: {
                    height?: string | number | import("long").Long;
                    format?: number;
                    chunks?: number;
                    hash?: Uint8Array;
                    metadata?: Uint8Array;
                }[];
            }): _98.ResponseListSnapshots;
            fromAmino(object: _98.ResponseListSnapshotsAmino): _98.ResponseListSnapshots;
            toAmino(message: _98.ResponseListSnapshots): _98.ResponseListSnapshotsAmino;
            fromAminoMsg(object: _98.ResponseListSnapshotsAminoMsg): _98.ResponseListSnapshots;
            fromProtoMsg(message: _98.ResponseListSnapshotsProtoMsg): _98.ResponseListSnapshots;
            toProto(message: _98.ResponseListSnapshots): Uint8Array;
            toProtoMsg(message: _98.ResponseListSnapshots): _98.ResponseListSnapshotsProtoMsg;
        };
        ResponseOfferSnapshot: {
            typeUrl: string;
            encode(message: _98.ResponseOfferSnapshot, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.ResponseOfferSnapshot;
            fromPartial(object: {
                result?: _98.ResponseOfferSnapshot_Result;
            }): _98.ResponseOfferSnapshot;
            fromAmino(object: _98.ResponseOfferSnapshotAmino): _98.ResponseOfferSnapshot;
            toAmino(message: _98.ResponseOfferSnapshot): _98.ResponseOfferSnapshotAmino;
            fromAminoMsg(object: _98.ResponseOfferSnapshotAminoMsg): _98.ResponseOfferSnapshot;
            fromProtoMsg(message: _98.ResponseOfferSnapshotProtoMsg): _98.ResponseOfferSnapshot;
            toProto(message: _98.ResponseOfferSnapshot): Uint8Array;
            toProtoMsg(message: _98.ResponseOfferSnapshot): _98.ResponseOfferSnapshotProtoMsg;
        };
        ResponseLoadSnapshotChunk: {
            typeUrl: string;
            encode(message: _98.ResponseLoadSnapshotChunk, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.ResponseLoadSnapshotChunk;
            fromPartial(object: {
                chunk?: Uint8Array;
            }): _98.ResponseLoadSnapshotChunk;
            fromAmino(object: _98.ResponseLoadSnapshotChunkAmino): _98.ResponseLoadSnapshotChunk;
            toAmino(message: _98.ResponseLoadSnapshotChunk): _98.ResponseLoadSnapshotChunkAmino;
            fromAminoMsg(object: _98.ResponseLoadSnapshotChunkAminoMsg): _98.ResponseLoadSnapshotChunk;
            fromProtoMsg(message: _98.ResponseLoadSnapshotChunkProtoMsg): _98.ResponseLoadSnapshotChunk;
            toProto(message: _98.ResponseLoadSnapshotChunk): Uint8Array;
            toProtoMsg(message: _98.ResponseLoadSnapshotChunk): _98.ResponseLoadSnapshotChunkProtoMsg;
        };
        ResponseApplySnapshotChunk: {
            typeUrl: string;
            encode(message: _98.ResponseApplySnapshotChunk, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.ResponseApplySnapshotChunk;
            fromPartial(object: {
                result?: _98.ResponseApplySnapshotChunk_Result;
                refetchChunks?: number[];
                rejectSenders?: string[];
            }): _98.ResponseApplySnapshotChunk;
            fromAmino(object: _98.ResponseApplySnapshotChunkAmino): _98.ResponseApplySnapshotChunk;
            toAmino(message: _98.ResponseApplySnapshotChunk): _98.ResponseApplySnapshotChunkAmino;
            fromAminoMsg(object: _98.ResponseApplySnapshotChunkAminoMsg): _98.ResponseApplySnapshotChunk;
            fromProtoMsg(message: _98.ResponseApplySnapshotChunkProtoMsg): _98.ResponseApplySnapshotChunk;
            toProto(message: _98.ResponseApplySnapshotChunk): Uint8Array;
            toProtoMsg(message: _98.ResponseApplySnapshotChunk): _98.ResponseApplySnapshotChunkProtoMsg;
        };
        ResponsePrepareProposal: {
            typeUrl: string;
            encode(message: _98.ResponsePrepareProposal, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.ResponsePrepareProposal;
            fromPartial(object: {
                txs?: Uint8Array[];
            }): _98.ResponsePrepareProposal;
            fromAmino(object: _98.ResponsePrepareProposalAmino): _98.ResponsePrepareProposal;
            toAmino(message: _98.ResponsePrepareProposal): _98.ResponsePrepareProposalAmino;
            fromAminoMsg(object: _98.ResponsePrepareProposalAminoMsg): _98.ResponsePrepareProposal;
            fromProtoMsg(message: _98.ResponsePrepareProposalProtoMsg): _98.ResponsePrepareProposal;
            toProto(message: _98.ResponsePrepareProposal): Uint8Array;
            toProtoMsg(message: _98.ResponsePrepareProposal): _98.ResponsePrepareProposalProtoMsg;
        };
        ResponseProcessProposal: {
            typeUrl: string;
            encode(message: _98.ResponseProcessProposal, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.ResponseProcessProposal;
            fromPartial(object: {
                status?: _98.ResponseProcessProposal_ProposalStatus;
            }): _98.ResponseProcessProposal;
            fromAmino(object: _98.ResponseProcessProposalAmino): _98.ResponseProcessProposal;
            toAmino(message: _98.ResponseProcessProposal): _98.ResponseProcessProposalAmino;
            fromAminoMsg(object: _98.ResponseProcessProposalAminoMsg): _98.ResponseProcessProposal;
            fromProtoMsg(message: _98.ResponseProcessProposalProtoMsg): _98.ResponseProcessProposal;
            toProto(message: _98.ResponseProcessProposal): Uint8Array;
            toProtoMsg(message: _98.ResponseProcessProposal): _98.ResponseProcessProposalProtoMsg;
        };
        ResponseExtendVote: {
            typeUrl: string;
            encode(message: _98.ResponseExtendVote, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.ResponseExtendVote;
            fromPartial(object: {
                voteExtension?: Uint8Array;
            }): _98.ResponseExtendVote;
            fromAmino(object: _98.ResponseExtendVoteAmino): _98.ResponseExtendVote;
            toAmino(message: _98.ResponseExtendVote): _98.ResponseExtendVoteAmino;
            fromAminoMsg(object: _98.ResponseExtendVoteAminoMsg): _98.ResponseExtendVote;
            fromProtoMsg(message: _98.ResponseExtendVoteProtoMsg): _98.ResponseExtendVote;
            toProto(message: _98.ResponseExtendVote): Uint8Array;
            toProtoMsg(message: _98.ResponseExtendVote): _98.ResponseExtendVoteProtoMsg;
        };
        ResponseVerifyVoteExtension: {
            typeUrl: string;
            encode(message: _98.ResponseVerifyVoteExtension, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.ResponseVerifyVoteExtension;
            fromPartial(object: {
                status?: _98.ResponseVerifyVoteExtension_VerifyStatus;
            }): _98.ResponseVerifyVoteExtension;
            fromAmino(object: _98.ResponseVerifyVoteExtensionAmino): _98.ResponseVerifyVoteExtension;
            toAmino(message: _98.ResponseVerifyVoteExtension): _98.ResponseVerifyVoteExtensionAmino;
            fromAminoMsg(object: _98.ResponseVerifyVoteExtensionAminoMsg): _98.ResponseVerifyVoteExtension;
            fromProtoMsg(message: _98.ResponseVerifyVoteExtensionProtoMsg): _98.ResponseVerifyVoteExtension;
            toProto(message: _98.ResponseVerifyVoteExtension): Uint8Array;
            toProtoMsg(message: _98.ResponseVerifyVoteExtension): _98.ResponseVerifyVoteExtensionProtoMsg;
        };
        ResponseFinalizeBlock: {
            typeUrl: string;
            encode(message: _98.ResponseFinalizeBlock, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.ResponseFinalizeBlock;
            fromPartial(object: {
                events?: {
                    type?: string;
                    attributes?: {
                        key?: string;
                        value?: string;
                        index?: boolean;
                    }[];
                }[];
                txResults?: {
                    code?: number;
                    data?: Uint8Array;
                    log?: string;
                    info?: string;
                    gasWanted?: string | number | import("long").Long;
                    gasUsed?: string | number | import("long").Long;
                    events?: {
                        type?: string;
                        attributes?: {
                            key?: string;
                            value?: string;
                            index?: boolean;
                        }[];
                    }[];
                    codespace?: string;
                }[];
                validatorUpdates?: {
                    pubKey?: {
                        ed25519?: Uint8Array;
                        secp256k1?: Uint8Array;
                    };
                    power?: string | number | import("long").Long;
                }[];
                consensusParamUpdates?: {
                    block?: {
                        maxBytes?: string | number | import("long").Long;
                        maxGas?: string | number | import("long").Long;
                    };
                    evidence?: {
                        maxAgeNumBlocks?: string | number | import("long").Long;
                        maxAgeDuration?: {
                            seconds?: string | number | import("long").Long;
                            nanos?: number;
                        };
                        maxBytes?: string | number | import("long").Long;
                    };
                    validator?: {
                        pubKeyTypes?: string[];
                    };
                    version?: {
                        app?: string | number | import("long").Long;
                    };
                    abci?: {
                        voteExtensionsEnableHeight?: string | number | import("long").Long;
                    };
                };
                appHash?: Uint8Array;
            }): _98.ResponseFinalizeBlock;
            fromAmino(object: _98.ResponseFinalizeBlockAmino): _98.ResponseFinalizeBlock;
            toAmino(message: _98.ResponseFinalizeBlock): _98.ResponseFinalizeBlockAmino;
            fromAminoMsg(object: _98.ResponseFinalizeBlockAminoMsg): _98.ResponseFinalizeBlock;
            fromProtoMsg(message: _98.ResponseFinalizeBlockProtoMsg): _98.ResponseFinalizeBlock;
            toProto(message: _98.ResponseFinalizeBlock): Uint8Array;
            toProtoMsg(message: _98.ResponseFinalizeBlock): _98.ResponseFinalizeBlockProtoMsg;
        };
        CommitInfo: {
            typeUrl: string;
            encode(message: _98.CommitInfo, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.CommitInfo;
            fromPartial(object: {
                round?: number;
                votes?: {
                    validator?: {
                        address?: Uint8Array;
                        power?: string | number | import("long").Long;
                    };
                    blockIdFlag?: _107.BlockIDFlag;
                }[];
            }): _98.CommitInfo;
            fromAmino(object: _98.CommitInfoAmino): _98.CommitInfo;
            toAmino(message: _98.CommitInfo): _98.CommitInfoAmino;
            fromAminoMsg(object: _98.CommitInfoAminoMsg): _98.CommitInfo;
            fromProtoMsg(message: _98.CommitInfoProtoMsg): _98.CommitInfo;
            toProto(message: _98.CommitInfo): Uint8Array;
            toProtoMsg(message: _98.CommitInfo): _98.CommitInfoProtoMsg;
        };
        ExtendedCommitInfo: {
            typeUrl: string;
            encode(message: _98.ExtendedCommitInfo, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.ExtendedCommitInfo;
            fromPartial(object: {
                round?: number;
                votes?: {
                    validator?: {
                        address?: Uint8Array;
                        power?: string | number | import("long").Long;
                    };
                    voteExtension?: Uint8Array;
                    extensionSignature?: Uint8Array;
                    blockIdFlag?: _107.BlockIDFlag;
                }[];
            }): _98.ExtendedCommitInfo;
            fromAmino(object: _98.ExtendedCommitInfoAmino): _98.ExtendedCommitInfo;
            toAmino(message: _98.ExtendedCommitInfo): _98.ExtendedCommitInfoAmino;
            fromAminoMsg(object: _98.ExtendedCommitInfoAminoMsg): _98.ExtendedCommitInfo;
            fromProtoMsg(message: _98.ExtendedCommitInfoProtoMsg): _98.ExtendedCommitInfo;
            toProto(message: _98.ExtendedCommitInfo): Uint8Array;
            toProtoMsg(message: _98.ExtendedCommitInfo): _98.ExtendedCommitInfoProtoMsg;
        };
        Event: {
            typeUrl: string;
            encode(message: _98.Event, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.Event;
            fromPartial(object: {
                type?: string;
                attributes?: {
                    key?: string;
                    value?: string;
                    index?: boolean;
                }[];
            }): _98.Event;
            fromAmino(object: _98.EventAmino): _98.Event;
            toAmino(message: _98.Event): _98.EventAmino;
            fromAminoMsg(object: _98.EventAminoMsg): _98.Event;
            fromProtoMsg(message: _98.EventProtoMsg): _98.Event;
            toProto(message: _98.Event): Uint8Array;
            toProtoMsg(message: _98.Event): _98.EventProtoMsg;
        };
        EventAttribute: {
            typeUrl: string;
            encode(message: _98.EventAttribute, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.EventAttribute;
            fromPartial(object: {
                key?: string;
                value?: string;
                index?: boolean;
            }): _98.EventAttribute;
            fromAmino(object: _98.EventAttributeAmino): _98.EventAttribute;
            toAmino(message: _98.EventAttribute): _98.EventAttributeAmino;
            fromAminoMsg(object: _98.EventAttributeAminoMsg): _98.EventAttribute;
            fromProtoMsg(message: _98.EventAttributeProtoMsg): _98.EventAttribute;
            toProto(message: _98.EventAttribute): Uint8Array;
            toProtoMsg(message: _98.EventAttribute): _98.EventAttributeProtoMsg;
        };
        ExecTxResult: {
            typeUrl: string;
            encode(message: _98.ExecTxResult, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.ExecTxResult;
            fromPartial(object: {
                code?: number;
                data?: Uint8Array;
                log?: string;
                info?: string;
                gasWanted?: string | number | import("long").Long;
                gasUsed?: string | number | import("long").Long;
                events?: {
                    type?: string;
                    attributes?: {
                        key?: string;
                        value?: string;
                        index?: boolean;
                    }[];
                }[];
                codespace?: string;
            }): _98.ExecTxResult;
            fromAmino(object: _98.ExecTxResultAmino): _98.ExecTxResult;
            toAmino(message: _98.ExecTxResult): _98.ExecTxResultAmino;
            fromAminoMsg(object: _98.ExecTxResultAminoMsg): _98.ExecTxResult;
            fromProtoMsg(message: _98.ExecTxResultProtoMsg): _98.ExecTxResult;
            toProto(message: _98.ExecTxResult): Uint8Array;
            toProtoMsg(message: _98.ExecTxResult): _98.ExecTxResultProtoMsg;
        };
        TxResult: {
            typeUrl: string;
            encode(message: _98.TxResult, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.TxResult;
            fromPartial(object: {
                height?: string | number | import("long").Long;
                index?: number;
                tx?: Uint8Array;
                result?: {
                    code?: number;
                    data?: Uint8Array;
                    log?: string;
                    info?: string;
                    gasWanted?: string | number | import("long").Long;
                    gasUsed?: string | number | import("long").Long;
                    events?: {
                        type?: string;
                        attributes?: {
                            key?: string;
                            value?: string;
                            index?: boolean;
                        }[];
                    }[];
                    codespace?: string;
                };
            }): _98.TxResult;
            fromAmino(object: _98.TxResultAmino): _98.TxResult;
            toAmino(message: _98.TxResult): _98.TxResultAmino;
            fromAminoMsg(object: _98.TxResultAminoMsg): _98.TxResult;
            fromProtoMsg(message: _98.TxResultProtoMsg): _98.TxResult;
            toProto(message: _98.TxResult): Uint8Array;
            toProtoMsg(message: _98.TxResult): _98.TxResultProtoMsg;
        };
        Validator: {
            typeUrl: string;
            encode(message: _98.Validator, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.Validator;
            fromPartial(object: {
                address?: Uint8Array;
                power?: string | number | import("long").Long;
            }): _98.Validator;
            fromAmino(object: _98.ValidatorAmino): _98.Validator;
            toAmino(message: _98.Validator): _98.ValidatorAmino;
            fromAminoMsg(object: _98.ValidatorAminoMsg): _98.Validator;
            fromProtoMsg(message: _98.ValidatorProtoMsg): _98.Validator;
            toProto(message: _98.Validator): Uint8Array;
            toProtoMsg(message: _98.Validator): _98.ValidatorProtoMsg;
        };
        ValidatorUpdate: {
            typeUrl: string;
            encode(message: _98.ValidatorUpdate, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.ValidatorUpdate;
            fromPartial(object: {
                pubKey?: {
                    ed25519?: Uint8Array;
                    secp256k1?: Uint8Array;
                };
                power?: string | number | import("long").Long;
            }): _98.ValidatorUpdate;
            fromAmino(object: _98.ValidatorUpdateAmino): _98.ValidatorUpdate;
            toAmino(message: _98.ValidatorUpdate): _98.ValidatorUpdateAmino;
            fromAminoMsg(object: _98.ValidatorUpdateAminoMsg): _98.ValidatorUpdate;
            fromProtoMsg(message: _98.ValidatorUpdateProtoMsg): _98.ValidatorUpdate;
            toProto(message: _98.ValidatorUpdate): Uint8Array;
            toProtoMsg(message: _98.ValidatorUpdate): _98.ValidatorUpdateProtoMsg;
        };
        VoteInfo: {
            typeUrl: string;
            encode(message: _98.VoteInfo, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.VoteInfo;
            fromPartial(object: {
                validator?: {
                    address?: Uint8Array;
                    power?: string | number | import("long").Long;
                };
                blockIdFlag?: _107.BlockIDFlag;
            }): _98.VoteInfo;
            fromAmino(object: _98.VoteInfoAmino): _98.VoteInfo;
            toAmino(message: _98.VoteInfo): _98.VoteInfoAmino;
            fromAminoMsg(object: _98.VoteInfoAminoMsg): _98.VoteInfo;
            fromProtoMsg(message: _98.VoteInfoProtoMsg): _98.VoteInfo;
            toProto(message: _98.VoteInfo): Uint8Array;
            toProtoMsg(message: _98.VoteInfo): _98.VoteInfoProtoMsg;
        };
        ExtendedVoteInfo: {
            typeUrl: string;
            encode(message: _98.ExtendedVoteInfo, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.ExtendedVoteInfo;
            fromPartial(object: {
                validator?: {
                    address?: Uint8Array;
                    power?: string | number | import("long").Long;
                };
                voteExtension?: Uint8Array;
                extensionSignature?: Uint8Array;
                blockIdFlag?: _107.BlockIDFlag;
            }): _98.ExtendedVoteInfo;
            fromAmino(object: _98.ExtendedVoteInfoAmino): _98.ExtendedVoteInfo;
            toAmino(message: _98.ExtendedVoteInfo): _98.ExtendedVoteInfoAmino;
            fromAminoMsg(object: _98.ExtendedVoteInfoAminoMsg): _98.ExtendedVoteInfo;
            fromProtoMsg(message: _98.ExtendedVoteInfoProtoMsg): _98.ExtendedVoteInfo;
            toProto(message: _98.ExtendedVoteInfo): Uint8Array;
            toProtoMsg(message: _98.ExtendedVoteInfo): _98.ExtendedVoteInfoProtoMsg;
        };
        Misbehavior: {
            typeUrl: string;
            encode(message: _98.Misbehavior, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.Misbehavior;
            fromPartial(object: {
                type?: _98.MisbehaviorType;
                validator?: {
                    address?: Uint8Array;
                    power?: string | number | import("long").Long;
                };
                height?: string | number | import("long").Long;
                time?: Date;
                totalVotingPower?: string | number | import("long").Long;
            }): _98.Misbehavior;
            fromAmino(object: _98.MisbehaviorAmino): _98.Misbehavior;
            toAmino(message: _98.Misbehavior): _98.MisbehaviorAmino;
            fromAminoMsg(object: _98.MisbehaviorAminoMsg): _98.Misbehavior;
            fromProtoMsg(message: _98.MisbehaviorProtoMsg): _98.Misbehavior;
            toProto(message: _98.Misbehavior): Uint8Array;
            toProtoMsg(message: _98.Misbehavior): _98.MisbehaviorProtoMsg;
        };
        Snapshot: {
            typeUrl: string;
            encode(message: _98.Snapshot, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _98.Snapshot;
            fromPartial(object: {
                height?: string | number | import("long").Long;
                format?: number;
                chunks?: number;
                hash?: Uint8Array;
                metadata?: Uint8Array;
            }): _98.Snapshot;
            fromAmino(object: _98.SnapshotAmino): _98.Snapshot;
            toAmino(message: _98.Snapshot): _98.SnapshotAmino;
            fromAminoMsg(object: _98.SnapshotAminoMsg): _98.Snapshot;
            fromProtoMsg(message: _98.SnapshotProtoMsg): _98.Snapshot;
            toProto(message: _98.Snapshot): Uint8Array;
            toProtoMsg(message: _98.Snapshot): _98.SnapshotProtoMsg;
        };
    };
    const crypto: {
        Proof: {
            typeUrl: string;
            encode(message: _100.Proof, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _100.Proof;
            fromPartial(object: {
                total?: string | number | import("long").Long;
                index?: string | number | import("long").Long;
                leafHash?: Uint8Array;
                aunts?: Uint8Array[];
            }): _100.Proof;
            fromAmino(object: _100.ProofAmino): _100.Proof;
            toAmino(message: _100.Proof): _100.ProofAmino;
            fromAminoMsg(object: _100.ProofAminoMsg): _100.Proof;
            fromProtoMsg(message: _100.ProofProtoMsg): _100.Proof;
            toProto(message: _100.Proof): Uint8Array;
            toProtoMsg(message: _100.Proof): _100.ProofProtoMsg;
        };
        ValueOp: {
            typeUrl: string;
            encode(message: _100.ValueOp, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _100.ValueOp;
            fromPartial(object: {
                key?: Uint8Array;
                proof?: {
                    total?: string | number | import("long").Long;
                    index?: string | number | import("long").Long;
                    leafHash?: Uint8Array;
                    aunts?: Uint8Array[];
                };
            }): _100.ValueOp;
            fromAmino(object: _100.ValueOpAmino): _100.ValueOp;
            toAmino(message: _100.ValueOp): _100.ValueOpAmino;
            fromAminoMsg(object: _100.ValueOpAminoMsg): _100.ValueOp;
            fromProtoMsg(message: _100.ValueOpProtoMsg): _100.ValueOp;
            toProto(message: _100.ValueOp): Uint8Array;
            toProtoMsg(message: _100.ValueOp): _100.ValueOpProtoMsg;
        };
        DominoOp: {
            typeUrl: string;
            encode(message: _100.DominoOp, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _100.DominoOp;
            fromPartial(object: {
                key?: string;
                input?: string;
                output?: string;
            }): _100.DominoOp;
            fromAmino(object: _100.DominoOpAmino): _100.DominoOp;
            toAmino(message: _100.DominoOp): _100.DominoOpAmino;
            fromAminoMsg(object: _100.DominoOpAminoMsg): _100.DominoOp;
            fromProtoMsg(message: _100.DominoOpProtoMsg): _100.DominoOp;
            toProto(message: _100.DominoOp): Uint8Array;
            toProtoMsg(message: _100.DominoOp): _100.DominoOpProtoMsg;
        };
        ProofOp: {
            typeUrl: string;
            encode(message: _100.ProofOp, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _100.ProofOp;
            fromPartial(object: {
                type?: string;
                key?: Uint8Array;
                data?: Uint8Array;
            }): _100.ProofOp;
            fromAmino(object: _100.ProofOpAmino): _100.ProofOp;
            toAmino(message: _100.ProofOp): _100.ProofOpAmino;
            fromAminoMsg(object: _100.ProofOpAminoMsg): _100.ProofOp;
            fromProtoMsg(message: _100.ProofOpProtoMsg): _100.ProofOp;
            toProto(message: _100.ProofOp): Uint8Array;
            toProtoMsg(message: _100.ProofOp): _100.ProofOpProtoMsg;
        };
        ProofOps: {
            typeUrl: string;
            encode(message: _100.ProofOps, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _100.ProofOps;
            fromPartial(object: {
                ops?: {
                    type?: string;
                    key?: Uint8Array;
                    data?: Uint8Array;
                }[];
            }): _100.ProofOps;
            fromAmino(object: _100.ProofOpsAmino): _100.ProofOps;
            toAmino(message: _100.ProofOps): _100.ProofOpsAmino;
            fromAminoMsg(object: _100.ProofOpsAminoMsg): _100.ProofOps;
            fromProtoMsg(message: _100.ProofOpsProtoMsg): _100.ProofOps;
            toProto(message: _100.ProofOps): Uint8Array;
            toProtoMsg(message: _100.ProofOps): _100.ProofOpsProtoMsg;
        };
        PublicKey: {
            typeUrl: string;
            encode(message: _99.PublicKey, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _99.PublicKey;
            fromPartial(object: {
                ed25519?: Uint8Array;
                secp256k1?: Uint8Array;
            }): _99.PublicKey;
            fromAmino(object: _99.PublicKeyAmino): _99.PublicKey;
            toAmino(message: _99.PublicKey): _99.PublicKeyAmino;
            fromAminoMsg(object: _99.PublicKeyAminoMsg): _99.PublicKey;
            fromProtoMsg(message: _99.PublicKeyProtoMsg): _99.PublicKey;
            toProto(message: _99.PublicKey): Uint8Array;
            toProtoMsg(message: _99.PublicKey): _99.PublicKeyProtoMsg;
        };
    };
    namespace libs {
        const bits: {
            BitArray: {
                typeUrl: string;
                encode(message: _101.BitArray, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
                decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _101.BitArray;
                fromPartial(object: {
                    bits?: string | number | import("long").Long;
                    elems?: (string | number | import("long").Long)[];
                }): _101.BitArray;
                fromAmino(object: _101.BitArrayAmino): _101.BitArray;
                toAmino(message: _101.BitArray): _101.BitArrayAmino;
                fromAminoMsg(object: _101.BitArrayAminoMsg): _101.BitArray;
                fromProtoMsg(message: _101.BitArrayProtoMsg): _101.BitArray;
                toProto(message: _101.BitArray): Uint8Array;
                toProtoMsg(message: _101.BitArray): _101.BitArrayProtoMsg;
            };
        };
    }
    const p2p: {
        NetAddress: {
            typeUrl: string;
            encode(message: _102.NetAddress, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _102.NetAddress;
            fromPartial(object: {
                id?: string;
                ip?: string;
                port?: number;
            }): _102.NetAddress;
            fromAmino(object: _102.NetAddressAmino): _102.NetAddress;
            toAmino(message: _102.NetAddress): _102.NetAddressAmino;
            fromAminoMsg(object: _102.NetAddressAminoMsg): _102.NetAddress;
            fromProtoMsg(message: _102.NetAddressProtoMsg): _102.NetAddress;
            toProto(message: _102.NetAddress): Uint8Array;
            toProtoMsg(message: _102.NetAddress): _102.NetAddressProtoMsg;
        };
        ProtocolVersion: {
            typeUrl: string;
            encode(message: _102.ProtocolVersion, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _102.ProtocolVersion;
            fromPartial(object: {
                p2p?: string | number | import("long").Long;
                block?: string | number | import("long").Long;
                app?: string | number | import("long").Long;
            }): _102.ProtocolVersion;
            fromAmino(object: _102.ProtocolVersionAmino): _102.ProtocolVersion;
            toAmino(message: _102.ProtocolVersion): _102.ProtocolVersionAmino;
            fromAminoMsg(object: _102.ProtocolVersionAminoMsg): _102.ProtocolVersion;
            fromProtoMsg(message: _102.ProtocolVersionProtoMsg): _102.ProtocolVersion;
            toProto(message: _102.ProtocolVersion): Uint8Array;
            toProtoMsg(message: _102.ProtocolVersion): _102.ProtocolVersionProtoMsg;
        };
        DefaultNodeInfo: {
            typeUrl: string;
            encode(message: _102.DefaultNodeInfo, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _102.DefaultNodeInfo;
            fromPartial(object: {
                protocolVersion?: {
                    p2p?: string | number | import("long").Long;
                    block?: string | number | import("long").Long;
                    app?: string | number | import("long").Long;
                };
                defaultNodeId?: string;
                listenAddr?: string;
                network?: string;
                version?: string;
                channels?: Uint8Array;
                moniker?: string;
                other?: {
                    txIndex?: string;
                    rpcAddress?: string;
                };
            }): _102.DefaultNodeInfo;
            fromAmino(object: _102.DefaultNodeInfoAmino): _102.DefaultNodeInfo;
            toAmino(message: _102.DefaultNodeInfo): _102.DefaultNodeInfoAmino;
            fromAminoMsg(object: _102.DefaultNodeInfoAminoMsg): _102.DefaultNodeInfo;
            fromProtoMsg(message: _102.DefaultNodeInfoProtoMsg): _102.DefaultNodeInfo;
            toProto(message: _102.DefaultNodeInfo): Uint8Array;
            toProtoMsg(message: _102.DefaultNodeInfo): _102.DefaultNodeInfoProtoMsg;
        };
        DefaultNodeInfoOther: {
            typeUrl: string;
            encode(message: _102.DefaultNodeInfoOther, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _102.DefaultNodeInfoOther;
            fromPartial(object: {
                txIndex?: string;
                rpcAddress?: string;
            }): _102.DefaultNodeInfoOther;
            fromAmino(object: _102.DefaultNodeInfoOtherAmino): _102.DefaultNodeInfoOther;
            toAmino(message: _102.DefaultNodeInfoOther): _102.DefaultNodeInfoOtherAmino;
            fromAminoMsg(object: _102.DefaultNodeInfoOtherAminoMsg): _102.DefaultNodeInfoOther;
            fromProtoMsg(message: _102.DefaultNodeInfoOtherProtoMsg): _102.DefaultNodeInfoOther;
            toProto(message: _102.DefaultNodeInfoOther): Uint8Array;
            toProtoMsg(message: _102.DefaultNodeInfoOther): _102.DefaultNodeInfoOtherProtoMsg;
        };
    };
    const types: {
        blockIDFlagFromJSON(object: any): _107.BlockIDFlag;
        blockIDFlagToJSON(object: _107.BlockIDFlag): string;
        BlockIDFlag: typeof _107.BlockIDFlag;
        BlockIDFlagSDKType: typeof _107.BlockIDFlag;
        BlockIDFlagAmino: typeof _107.BlockIDFlag;
        ValidatorSet: {
            typeUrl: string;
            encode(message: _107.ValidatorSet, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _107.ValidatorSet;
            fromPartial(object: {
                validators?: {
                    address?: Uint8Array;
                    pubKey?: {
                        ed25519?: Uint8Array;
                        secp256k1?: Uint8Array;
                    };
                    votingPower?: string | number | import("long").Long;
                    proposerPriority?: string | number | import("long").Long;
                }[];
                proposer?: {
                    address?: Uint8Array;
                    pubKey?: {
                        ed25519?: Uint8Array;
                        secp256k1?: Uint8Array;
                    };
                    votingPower?: string | number | import("long").Long;
                    proposerPriority?: string | number | import("long").Long;
                };
                totalVotingPower?: string | number | import("long").Long;
            }): _107.ValidatorSet;
            fromAmino(object: _107.ValidatorSetAmino): _107.ValidatorSet;
            toAmino(message: _107.ValidatorSet): _107.ValidatorSetAmino;
            fromAminoMsg(object: _107.ValidatorSetAminoMsg): _107.ValidatorSet;
            fromProtoMsg(message: _107.ValidatorSetProtoMsg): _107.ValidatorSet;
            toProto(message: _107.ValidatorSet): Uint8Array;
            toProtoMsg(message: _107.ValidatorSet): _107.ValidatorSetProtoMsg;
        };
        Validator: {
            typeUrl: string;
            encode(message: _107.Validator, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _107.Validator;
            fromPartial(object: {
                address?: Uint8Array;
                pubKey?: {
                    ed25519?: Uint8Array;
                    secp256k1?: Uint8Array;
                };
                votingPower?: string | number | import("long").Long;
                proposerPriority?: string | number | import("long").Long;
            }): _107.Validator;
            fromAmino(object: _107.ValidatorAmino): _107.Validator;
            toAmino(message: _107.Validator): _107.ValidatorAmino;
            fromAminoMsg(object: _107.ValidatorAminoMsg): _107.Validator;
            fromProtoMsg(message: _107.ValidatorProtoMsg): _107.Validator;
            toProto(message: _107.Validator): Uint8Array;
            toProtoMsg(message: _107.Validator): _107.ValidatorProtoMsg;
        };
        SimpleValidator: {
            typeUrl: string;
            encode(message: _107.SimpleValidator, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _107.SimpleValidator;
            fromPartial(object: {
                pubKey?: {
                    ed25519?: Uint8Array;
                    secp256k1?: Uint8Array;
                };
                votingPower?: string | number | import("long").Long;
            }): _107.SimpleValidator;
            fromAmino(object: _107.SimpleValidatorAmino): _107.SimpleValidator;
            toAmino(message: _107.SimpleValidator): _107.SimpleValidatorAmino;
            fromAminoMsg(object: _107.SimpleValidatorAminoMsg): _107.SimpleValidator;
            fromProtoMsg(message: _107.SimpleValidatorProtoMsg): _107.SimpleValidator;
            toProto(message: _107.SimpleValidator): Uint8Array;
            toProtoMsg(message: _107.SimpleValidator): _107.SimpleValidatorProtoMsg;
        };
        signedMsgTypeFromJSON(object: any): _106.SignedMsgType;
        signedMsgTypeToJSON(object: _106.SignedMsgType): string;
        SignedMsgType: typeof _106.SignedMsgType;
        SignedMsgTypeSDKType: typeof _106.SignedMsgType;
        SignedMsgTypeAmino: typeof _106.SignedMsgType;
        PartSetHeader: {
            typeUrl: string;
            encode(message: _106.PartSetHeader, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _106.PartSetHeader;
            fromPartial(object: {
                total?: number;
                hash?: Uint8Array;
            }): _106.PartSetHeader;
            fromAmino(object: _106.PartSetHeaderAmino): _106.PartSetHeader;
            toAmino(message: _106.PartSetHeader): _106.PartSetHeaderAmino;
            fromAminoMsg(object: _106.PartSetHeaderAminoMsg): _106.PartSetHeader;
            fromProtoMsg(message: _106.PartSetHeaderProtoMsg): _106.PartSetHeader;
            toProto(message: _106.PartSetHeader): Uint8Array;
            toProtoMsg(message: _106.PartSetHeader): _106.PartSetHeaderProtoMsg;
        };
        Part: {
            typeUrl: string;
            encode(message: _106.Part, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _106.Part;
            fromPartial(object: {
                index?: number;
                bytes?: Uint8Array;
                proof?: {
                    total?: string | number | import("long").Long;
                    index?: string | number | import("long").Long;
                    leafHash?: Uint8Array;
                    aunts?: Uint8Array[];
                };
            }): _106.Part;
            fromAmino(object: _106.PartAmino): _106.Part;
            toAmino(message: _106.Part): _106.PartAmino;
            fromAminoMsg(object: _106.PartAminoMsg): _106.Part;
            fromProtoMsg(message: _106.PartProtoMsg): _106.Part;
            toProto(message: _106.Part): Uint8Array;
            toProtoMsg(message: _106.Part): _106.PartProtoMsg;
        };
        BlockID: {
            typeUrl: string;
            encode(message: _106.BlockID, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _106.BlockID;
            fromPartial(object: {
                hash?: Uint8Array;
                partSetHeader?: {
                    total?: number;
                    hash?: Uint8Array;
                };
            }): _106.BlockID;
            fromAmino(object: _106.BlockIDAmino): _106.BlockID;
            toAmino(message: _106.BlockID): _106.BlockIDAmino;
            fromAminoMsg(object: _106.BlockIDAminoMsg): _106.BlockID;
            fromProtoMsg(message: _106.BlockIDProtoMsg): _106.BlockID;
            toProto(message: _106.BlockID): Uint8Array;
            toProtoMsg(message: _106.BlockID): _106.BlockIDProtoMsg;
        };
        Header: {
            typeUrl: string;
            encode(message: _106.Header, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _106.Header;
            fromPartial(object: {
                version?: {
                    block?: string | number | import("long").Long;
                    app?: string | number | import("long").Long;
                };
                chainId?: string;
                height?: string | number | import("long").Long;
                time?: Date;
                lastBlockId?: {
                    hash?: Uint8Array;
                    partSetHeader?: {
                        total?: number;
                        hash?: Uint8Array;
                    };
                };
                lastCommitHash?: Uint8Array;
                dataHash?: Uint8Array;
                validatorsHash?: Uint8Array;
                nextValidatorsHash?: Uint8Array;
                consensusHash?: Uint8Array;
                appHash?: Uint8Array;
                lastResultsHash?: Uint8Array;
                evidenceHash?: Uint8Array;
                proposerAddress?: Uint8Array;
            }): _106.Header;
            fromAmino(object: _106.HeaderAmino): _106.Header;
            toAmino(message: _106.Header): _106.HeaderAmino;
            fromAminoMsg(object: _106.HeaderAminoMsg): _106.Header;
            fromProtoMsg(message: _106.HeaderProtoMsg): _106.Header;
            toProto(message: _106.Header): Uint8Array;
            toProtoMsg(message: _106.Header): _106.HeaderProtoMsg;
        };
        Data: {
            typeUrl: string;
            encode(message: _106.Data, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _106.Data;
            fromPartial(object: {
                txs?: Uint8Array[];
            }): _106.Data;
            fromAmino(object: _106.DataAmino): _106.Data;
            toAmino(message: _106.Data): _106.DataAmino;
            fromAminoMsg(object: _106.DataAminoMsg): _106.Data;
            fromProtoMsg(message: _106.DataProtoMsg): _106.Data;
            toProto(message: _106.Data): Uint8Array;
            toProtoMsg(message: _106.Data): _106.DataProtoMsg;
        };
        Vote: {
            typeUrl: string;
            encode(message: _106.Vote, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _106.Vote;
            fromPartial(object: {
                type?: _106.SignedMsgType;
                height?: string | number | import("long").Long;
                round?: number;
                blockId?: {
                    hash?: Uint8Array;
                    partSetHeader?: {
                        total?: number;
                        hash?: Uint8Array;
                    };
                };
                timestamp?: Date;
                validatorAddress?: Uint8Array;
                validatorIndex?: number;
                signature?: Uint8Array;
                extension?: Uint8Array;
                extensionSignature?: Uint8Array;
            }): _106.Vote;
            fromAmino(object: _106.VoteAmino): _106.Vote;
            toAmino(message: _106.Vote): _106.VoteAmino;
            fromAminoMsg(object: _106.VoteAminoMsg): _106.Vote;
            fromProtoMsg(message: _106.VoteProtoMsg): _106.Vote;
            toProto(message: _106.Vote): Uint8Array;
            toProtoMsg(message: _106.Vote): _106.VoteProtoMsg;
        };
        Commit: {
            typeUrl: string;
            encode(message: _106.Commit, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _106.Commit;
            fromPartial(object: {
                height?: string | number | import("long").Long;
                round?: number;
                blockId?: {
                    hash?: Uint8Array;
                    partSetHeader?: {
                        total?: number;
                        hash?: Uint8Array;
                    };
                };
                signatures?: {
                    blockIdFlag?: _107.BlockIDFlag;
                    validatorAddress?: Uint8Array;
                    timestamp?: Date;
                    signature?: Uint8Array;
                }[];
            }): _106.Commit;
            fromAmino(object: _106.CommitAmino): _106.Commit;
            toAmino(message: _106.Commit): _106.CommitAmino;
            fromAminoMsg(object: _106.CommitAminoMsg): _106.Commit;
            fromProtoMsg(message: _106.CommitProtoMsg): _106.Commit;
            toProto(message: _106.Commit): Uint8Array;
            toProtoMsg(message: _106.Commit): _106.CommitProtoMsg;
        };
        CommitSig: {
            typeUrl: string;
            encode(message: _106.CommitSig, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _106.CommitSig;
            fromPartial(object: {
                blockIdFlag?: _107.BlockIDFlag;
                validatorAddress?: Uint8Array;
                timestamp?: Date;
                signature?: Uint8Array;
            }): _106.CommitSig;
            fromAmino(object: _106.CommitSigAmino): _106.CommitSig;
            toAmino(message: _106.CommitSig): _106.CommitSigAmino;
            fromAminoMsg(object: _106.CommitSigAminoMsg): _106.CommitSig;
            fromProtoMsg(message: _106.CommitSigProtoMsg): _106.CommitSig;
            toProto(message: _106.CommitSig): Uint8Array;
            toProtoMsg(message: _106.CommitSig): _106.CommitSigProtoMsg;
        };
        ExtendedCommit: {
            typeUrl: string;
            encode(message: _106.ExtendedCommit, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _106.ExtendedCommit;
            fromPartial(object: {
                height?: string | number | import("long").Long;
                round?: number;
                blockId?: {
                    hash?: Uint8Array;
                    partSetHeader?: {
                        total?: number;
                        hash?: Uint8Array;
                    };
                };
                extendedSignatures?: {
                    blockIdFlag?: _107.BlockIDFlag;
                    validatorAddress?: Uint8Array;
                    timestamp?: Date;
                    signature?: Uint8Array;
                    extension?: Uint8Array;
                    extensionSignature?: Uint8Array;
                }[];
            }): _106.ExtendedCommit;
            fromAmino(object: _106.ExtendedCommitAmino): _106.ExtendedCommit;
            toAmino(message: _106.ExtendedCommit): _106.ExtendedCommitAmino;
            fromAminoMsg(object: _106.ExtendedCommitAminoMsg): _106.ExtendedCommit;
            fromProtoMsg(message: _106.ExtendedCommitProtoMsg): _106.ExtendedCommit;
            toProto(message: _106.ExtendedCommit): Uint8Array;
            toProtoMsg(message: _106.ExtendedCommit): _106.ExtendedCommitProtoMsg;
        };
        ExtendedCommitSig: {
            typeUrl: string;
            encode(message: _106.ExtendedCommitSig, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _106.ExtendedCommitSig;
            fromPartial(object: {
                blockIdFlag?: _107.BlockIDFlag;
                validatorAddress?: Uint8Array;
                timestamp?: Date;
                signature?: Uint8Array;
                extension?: Uint8Array;
                extensionSignature?: Uint8Array;
            }): _106.ExtendedCommitSig;
            fromAmino(object: _106.ExtendedCommitSigAmino): _106.ExtendedCommitSig;
            toAmino(message: _106.ExtendedCommitSig): _106.ExtendedCommitSigAmino;
            fromAminoMsg(object: _106.ExtendedCommitSigAminoMsg): _106.ExtendedCommitSig;
            fromProtoMsg(message: _106.ExtendedCommitSigProtoMsg): _106.ExtendedCommitSig;
            toProto(message: _106.ExtendedCommitSig): Uint8Array;
            toProtoMsg(message: _106.ExtendedCommitSig): _106.ExtendedCommitSigProtoMsg;
        };
        Proposal: {
            typeUrl: string;
            encode(message: _106.Proposal, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _106.Proposal;
            fromPartial(object: {
                type?: _106.SignedMsgType;
                height?: string | number | import("long").Long;
                round?: number;
                polRound?: number;
                blockId?: {
                    hash?: Uint8Array;
                    partSetHeader?: {
                        total?: number;
                        hash?: Uint8Array;
                    };
                };
                timestamp?: Date;
                signature?: Uint8Array;
            }): _106.Proposal;
            fromAmino(object: _106.ProposalAmino): _106.Proposal;
            toAmino(message: _106.Proposal): _106.ProposalAmino;
            fromAminoMsg(object: _106.ProposalAminoMsg): _106.Proposal;
            fromProtoMsg(message: _106.ProposalProtoMsg): _106.Proposal;
            toProto(message: _106.Proposal): Uint8Array;
            toProtoMsg(message: _106.Proposal): _106.ProposalProtoMsg;
        };
        SignedHeader: {
            typeUrl: string;
            encode(message: _106.SignedHeader, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _106.SignedHeader;
            fromPartial(object: {
                header?: {
                    version?: {
                        block?: string | number | import("long").Long;
                        app?: string | number | import("long").Long;
                    };
                    chainId?: string;
                    height?: string | number | import("long").Long;
                    time?: Date;
                    lastBlockId?: {
                        hash?: Uint8Array;
                        partSetHeader?: {
                            total?: number;
                            hash?: Uint8Array;
                        };
                    };
                    lastCommitHash?: Uint8Array;
                    dataHash?: Uint8Array;
                    validatorsHash?: Uint8Array;
                    nextValidatorsHash?: Uint8Array;
                    consensusHash?: Uint8Array;
                    appHash?: Uint8Array;
                    lastResultsHash?: Uint8Array;
                    evidenceHash?: Uint8Array;
                    proposerAddress?: Uint8Array;
                };
                commit?: {
                    height?: string | number | import("long").Long;
                    round?: number;
                    blockId?: {
                        hash?: Uint8Array;
                        partSetHeader?: {
                            total?: number;
                            hash?: Uint8Array;
                        };
                    };
                    signatures?: {
                        blockIdFlag?: _107.BlockIDFlag;
                        validatorAddress?: Uint8Array;
                        timestamp?: Date;
                        signature?: Uint8Array;
                    }[];
                };
            }): _106.SignedHeader;
            fromAmino(object: _106.SignedHeaderAmino): _106.SignedHeader;
            toAmino(message: _106.SignedHeader): _106.SignedHeaderAmino;
            fromAminoMsg(object: _106.SignedHeaderAminoMsg): _106.SignedHeader;
            fromProtoMsg(message: _106.SignedHeaderProtoMsg): _106.SignedHeader;
            toProto(message: _106.SignedHeader): Uint8Array;
            toProtoMsg(message: _106.SignedHeader): _106.SignedHeaderProtoMsg;
        };
        LightBlock: {
            typeUrl: string;
            encode(message: _106.LightBlock, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _106.LightBlock;
            fromPartial(object: {
                signedHeader?: {
                    header?: {
                        version?: {
                            block?: string | number | import("long").Long;
                            app?: string | number | import("long").Long;
                        };
                        chainId?: string;
                        height?: string | number | import("long").Long;
                        time?: Date;
                        lastBlockId?: {
                            hash?: Uint8Array;
                            partSetHeader?: {
                                total?: number;
                                hash?: Uint8Array;
                            };
                        };
                        lastCommitHash?: Uint8Array;
                        dataHash?: Uint8Array;
                        validatorsHash?: Uint8Array;
                        nextValidatorsHash?: Uint8Array;
                        consensusHash?: Uint8Array;
                        appHash?: Uint8Array;
                        lastResultsHash?: Uint8Array;
                        evidenceHash?: Uint8Array;
                        proposerAddress?: Uint8Array;
                    };
                    commit?: {
                        height?: string | number | import("long").Long;
                        round?: number;
                        blockId?: {
                            hash?: Uint8Array;
                            partSetHeader?: {
                                total?: number;
                                hash?: Uint8Array;
                            };
                        };
                        signatures?: {
                            blockIdFlag?: _107.BlockIDFlag;
                            validatorAddress?: Uint8Array;
                            timestamp?: Date;
                            signature?: Uint8Array;
                        }[];
                    };
                };
                validatorSet?: {
                    validators?: {
                        address?: Uint8Array;
                        pubKey?: {
                            ed25519?: Uint8Array;
                            secp256k1?: Uint8Array;
                        };
                        votingPower?: string | number | import("long").Long;
                        proposerPriority?: string | number | import("long").Long;
                    }[];
                    proposer?: {
                        address?: Uint8Array;
                        pubKey?: {
                            ed25519?: Uint8Array;
                            secp256k1?: Uint8Array;
                        };
                        votingPower?: string | number | import("long").Long;
                        proposerPriority?: string | number | import("long").Long;
                    };
                    totalVotingPower?: string | number | import("long").Long;
                };
            }): _106.LightBlock;
            fromAmino(object: _106.LightBlockAmino): _106.LightBlock;
            toAmino(message: _106.LightBlock): _106.LightBlockAmino;
            fromAminoMsg(object: _106.LightBlockAminoMsg): _106.LightBlock;
            fromProtoMsg(message: _106.LightBlockProtoMsg): _106.LightBlock;
            toProto(message: _106.LightBlock): Uint8Array;
            toProtoMsg(message: _106.LightBlock): _106.LightBlockProtoMsg;
        };
        BlockMeta: {
            typeUrl: string;
            encode(message: _106.BlockMeta, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _106.BlockMeta;
            fromPartial(object: {
                blockId?: {
                    hash?: Uint8Array;
                    partSetHeader?: {
                        total?: number;
                        hash?: Uint8Array;
                    };
                };
                blockSize?: string | number | import("long").Long;
                header?: {
                    version?: {
                        block?: string | number | import("long").Long;
                        app?: string | number | import("long").Long;
                    };
                    chainId?: string;
                    height?: string | number | import("long").Long;
                    time?: Date;
                    lastBlockId?: {
                        hash?: Uint8Array;
                        partSetHeader?: {
                            total?: number;
                            hash?: Uint8Array;
                        };
                    };
                    lastCommitHash?: Uint8Array;
                    dataHash?: Uint8Array;
                    validatorsHash?: Uint8Array;
                    nextValidatorsHash?: Uint8Array;
                    consensusHash?: Uint8Array;
                    appHash?: Uint8Array;
                    lastResultsHash?: Uint8Array;
                    evidenceHash?: Uint8Array;
                    proposerAddress?: Uint8Array;
                };
                numTxs?: string | number | import("long").Long;
            }): _106.BlockMeta;
            fromAmino(object: _106.BlockMetaAmino): _106.BlockMeta;
            toAmino(message: _106.BlockMeta): _106.BlockMetaAmino;
            fromAminoMsg(object: _106.BlockMetaAminoMsg): _106.BlockMeta;
            fromProtoMsg(message: _106.BlockMetaProtoMsg): _106.BlockMeta;
            toProto(message: _106.BlockMeta): Uint8Array;
            toProtoMsg(message: _106.BlockMeta): _106.BlockMetaProtoMsg;
        };
        TxProof: {
            typeUrl: string;
            encode(message: _106.TxProof, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _106.TxProof;
            fromPartial(object: {
                rootHash?: Uint8Array;
                data?: Uint8Array;
                proof?: {
                    total?: string | number | import("long").Long;
                    index?: string | number | import("long").Long;
                    leafHash?: Uint8Array;
                    aunts?: Uint8Array[];
                };
            }): _106.TxProof;
            fromAmino(object: _106.TxProofAmino): _106.TxProof;
            toAmino(message: _106.TxProof): _106.TxProofAmino;
            fromAminoMsg(object: _106.TxProofAminoMsg): _106.TxProof;
            fromProtoMsg(message: _106.TxProofProtoMsg): _106.TxProof;
            toProto(message: _106.TxProof): Uint8Array;
            toProtoMsg(message: _106.TxProof): _106.TxProofProtoMsg;
        };
        ConsensusParams: {
            typeUrl: string;
            encode(message: _105.ConsensusParams, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _105.ConsensusParams;
            fromPartial(object: {
                block?: {
                    maxBytes?: string | number | import("long").Long;
                    maxGas?: string | number | import("long").Long;
                };
                evidence?: {
                    maxAgeNumBlocks?: string | number | import("long").Long;
                    maxAgeDuration?: {
                        seconds?: string | number | import("long").Long;
                        nanos?: number;
                    };
                    maxBytes?: string | number | import("long").Long;
                };
                validator?: {
                    pubKeyTypes?: string[];
                };
                version?: {
                    app?: string | number | import("long").Long;
                };
                abci?: {
                    voteExtensionsEnableHeight?: string | number | import("long").Long;
                };
            }): _105.ConsensusParams;
            fromAmino(object: _105.ConsensusParamsAmino): _105.ConsensusParams;
            toAmino(message: _105.ConsensusParams): _105.ConsensusParamsAmino;
            fromAminoMsg(object: _105.ConsensusParamsAminoMsg): _105.ConsensusParams;
            fromProtoMsg(message: _105.ConsensusParamsProtoMsg): _105.ConsensusParams;
            toProto(message: _105.ConsensusParams): Uint8Array;
            toProtoMsg(message: _105.ConsensusParams): _105.ConsensusParamsProtoMsg;
        };
        BlockParams: {
            typeUrl: string;
            encode(message: _105.BlockParams, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _105.BlockParams;
            fromPartial(object: {
                maxBytes?: string | number | import("long").Long;
                maxGas?: string | number | import("long").Long;
            }): _105.BlockParams;
            fromAmino(object: _105.BlockParamsAmino): _105.BlockParams;
            toAmino(message: _105.BlockParams): _105.BlockParamsAmino;
            fromAminoMsg(object: _105.BlockParamsAminoMsg): _105.BlockParams;
            fromProtoMsg(message: _105.BlockParamsProtoMsg): _105.BlockParams;
            toProto(message: _105.BlockParams): Uint8Array;
            toProtoMsg(message: _105.BlockParams): _105.BlockParamsProtoMsg;
        };
        EvidenceParams: {
            typeUrl: string;
            encode(message: _105.EvidenceParams, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _105.EvidenceParams;
            fromPartial(object: {
                maxAgeNumBlocks?: string | number | import("long").Long;
                maxAgeDuration?: {
                    seconds?: string | number | import("long").Long;
                    nanos?: number;
                };
                maxBytes?: string | number | import("long").Long;
            }): _105.EvidenceParams;
            fromAmino(object: _105.EvidenceParamsAmino): _105.EvidenceParams;
            toAmino(message: _105.EvidenceParams): _105.EvidenceParamsAmino;
            fromAminoMsg(object: _105.EvidenceParamsAminoMsg): _105.EvidenceParams;
            fromProtoMsg(message: _105.EvidenceParamsProtoMsg): _105.EvidenceParams;
            toProto(message: _105.EvidenceParams): Uint8Array;
            toProtoMsg(message: _105.EvidenceParams): _105.EvidenceParamsProtoMsg;
        };
        ValidatorParams: {
            typeUrl: string;
            encode(message: _105.ValidatorParams, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _105.ValidatorParams;
            fromPartial(object: {
                pubKeyTypes?: string[];
            }): _105.ValidatorParams;
            fromAmino(object: _105.ValidatorParamsAmino): _105.ValidatorParams;
            toAmino(message: _105.ValidatorParams): _105.ValidatorParamsAmino;
            fromAminoMsg(object: _105.ValidatorParamsAminoMsg): _105.ValidatorParams;
            fromProtoMsg(message: _105.ValidatorParamsProtoMsg): _105.ValidatorParams;
            toProto(message: _105.ValidatorParams): Uint8Array;
            toProtoMsg(message: _105.ValidatorParams): _105.ValidatorParamsProtoMsg;
        };
        VersionParams: {
            typeUrl: string;
            encode(message: _105.VersionParams, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _105.VersionParams;
            fromPartial(object: {
                app?: string | number | import("long").Long;
            }): _105.VersionParams;
            fromAmino(object: _105.VersionParamsAmino): _105.VersionParams;
            toAmino(message: _105.VersionParams): _105.VersionParamsAmino;
            fromAminoMsg(object: _105.VersionParamsAminoMsg): _105.VersionParams;
            fromProtoMsg(message: _105.VersionParamsProtoMsg): _105.VersionParams;
            toProto(message: _105.VersionParams): Uint8Array;
            toProtoMsg(message: _105.VersionParams): _105.VersionParamsProtoMsg;
        };
        HashedParams: {
            typeUrl: string;
            encode(message: _105.HashedParams, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _105.HashedParams;
            fromPartial(object: {
                blockMaxBytes?: string | number | import("long").Long;
                blockMaxGas?: string | number | import("long").Long;
            }): _105.HashedParams;
            fromAmino(object: _105.HashedParamsAmino): _105.HashedParams;
            toAmino(message: _105.HashedParams): _105.HashedParamsAmino;
            fromAminoMsg(object: _105.HashedParamsAminoMsg): _105.HashedParams;
            fromProtoMsg(message: _105.HashedParamsProtoMsg): _105.HashedParams;
            toProto(message: _105.HashedParams): Uint8Array;
            toProtoMsg(message: _105.HashedParams): _105.HashedParamsProtoMsg;
        };
        ABCIParams: {
            typeUrl: string;
            encode(message: _105.ABCIParams, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _105.ABCIParams;
            fromPartial(object: {
                voteExtensionsEnableHeight?: string | number | import("long").Long;
            }): _105.ABCIParams;
            fromAmino(object: _105.ABCIParamsAmino): _105.ABCIParams;
            toAmino(message: _105.ABCIParams): _105.ABCIParamsAmino;
            fromAminoMsg(object: _105.ABCIParamsAminoMsg): _105.ABCIParams;
            fromProtoMsg(message: _105.ABCIParamsProtoMsg): _105.ABCIParams;
            toProto(message: _105.ABCIParams): Uint8Array;
            toProtoMsg(message: _105.ABCIParams): _105.ABCIParamsProtoMsg;
        };
        Evidence: {
            typeUrl: string;
            encode(message: _104.Evidence, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _104.Evidence;
            fromPartial(object: {
                duplicateVoteEvidence?: {
                    voteA?: {
                        type?: _106.SignedMsgType;
                        height?: string | number | import("long").Long;
                        round?: number;
                        blockId?: {
                            hash?: Uint8Array;
                            partSetHeader?: {
                                total?: number;
                                hash?: Uint8Array;
                            };
                        };
                        timestamp?: Date;
                        validatorAddress?: Uint8Array;
                        validatorIndex?: number;
                        signature?: Uint8Array;
                        extension?: Uint8Array;
                        extensionSignature?: Uint8Array;
                    };
                    voteB?: {
                        type?: _106.SignedMsgType;
                        height?: string | number | import("long").Long;
                        round?: number;
                        blockId?: {
                            hash?: Uint8Array;
                            partSetHeader?: {
                                total?: number;
                                hash?: Uint8Array;
                            };
                        };
                        timestamp?: Date;
                        validatorAddress?: Uint8Array;
                        validatorIndex?: number;
                        signature?: Uint8Array;
                        extension?: Uint8Array;
                        extensionSignature?: Uint8Array;
                    };
                    totalVotingPower?: string | number | import("long").Long;
                    validatorPower?: string | number | import("long").Long;
                    timestamp?: Date;
                };
                lightClientAttackEvidence?: {
                    conflictingBlock?: {
                        signedHeader?: {
                            header?: {
                                version?: {
                                    block?: string | number | import("long").Long;
                                    app?: string | number | import("long").Long;
                                };
                                chainId?: string;
                                height?: string | number | import("long").Long;
                                time?: Date;
                                lastBlockId?: {
                                    hash?: Uint8Array;
                                    partSetHeader?: {
                                        total?: number;
                                        hash?: Uint8Array;
                                    };
                                };
                                lastCommitHash?: Uint8Array;
                                dataHash?: Uint8Array;
                                validatorsHash?: Uint8Array;
                                nextValidatorsHash?: Uint8Array;
                                consensusHash?: Uint8Array;
                                appHash?: Uint8Array;
                                lastResultsHash?: Uint8Array;
                                evidenceHash?: Uint8Array;
                                proposerAddress?: Uint8Array;
                            };
                            commit?: {
                                height?: string | number | import("long").Long;
                                round?: number;
                                blockId?: {
                                    hash?: Uint8Array;
                                    partSetHeader?: {
                                        total?: number;
                                        hash?: Uint8Array;
                                    };
                                };
                                signatures?: {
                                    blockIdFlag?: _107.BlockIDFlag;
                                    validatorAddress?: Uint8Array;
                                    timestamp?: Date;
                                    signature?: Uint8Array;
                                }[];
                            };
                        };
                        validatorSet?: {
                            validators?: {
                                address?: Uint8Array;
                                pubKey?: {
                                    ed25519?: Uint8Array;
                                    secp256k1?: Uint8Array;
                                };
                                votingPower?: string | number | import("long").Long;
                                proposerPriority?: string | number | import("long").Long;
                            }[];
                            proposer?: {
                                address?: Uint8Array;
                                pubKey?: {
                                    ed25519?: Uint8Array;
                                    secp256k1?: Uint8Array;
                                };
                                votingPower?: string | number | import("long").Long;
                                proposerPriority?: string | number | import("long").Long;
                            };
                            totalVotingPower?: string | number | import("long").Long;
                        };
                    };
                    commonHeight?: string | number | import("long").Long;
                    byzantineValidators?: {
                        address?: Uint8Array;
                        pubKey?: {
                            ed25519?: Uint8Array;
                            secp256k1?: Uint8Array;
                        };
                        votingPower?: string | number | import("long").Long;
                        proposerPriority?: string | number | import("long").Long;
                    }[];
                    totalVotingPower?: string | number | import("long").Long;
                    timestamp?: Date;
                };
            }): _104.Evidence;
            fromAmino(object: _104.EvidenceAmino): _104.Evidence;
            toAmino(message: _104.Evidence): _104.EvidenceAmino;
            fromAminoMsg(object: _104.EvidenceAminoMsg): _104.Evidence;
            fromProtoMsg(message: _104.EvidenceProtoMsg): _104.Evidence;
            toProto(message: _104.Evidence): Uint8Array;
            toProtoMsg(message: _104.Evidence): _104.EvidenceProtoMsg;
        };
        DuplicateVoteEvidence: {
            typeUrl: string;
            encode(message: _104.DuplicateVoteEvidence, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _104.DuplicateVoteEvidence;
            fromPartial(object: {
                voteA?: {
                    type?: _106.SignedMsgType;
                    height?: string | number | import("long").Long;
                    round?: number;
                    blockId?: {
                        hash?: Uint8Array;
                        partSetHeader?: {
                            total?: number;
                            hash?: Uint8Array;
                        };
                    };
                    timestamp?: Date;
                    validatorAddress?: Uint8Array;
                    validatorIndex?: number;
                    signature?: Uint8Array;
                    extension?: Uint8Array;
                    extensionSignature?: Uint8Array;
                };
                voteB?: {
                    type?: _106.SignedMsgType;
                    height?: string | number | import("long").Long;
                    round?: number;
                    blockId?: {
                        hash?: Uint8Array;
                        partSetHeader?: {
                            total?: number;
                            hash?: Uint8Array;
                        };
                    };
                    timestamp?: Date;
                    validatorAddress?: Uint8Array;
                    validatorIndex?: number;
                    signature?: Uint8Array;
                    extension?: Uint8Array;
                    extensionSignature?: Uint8Array;
                };
                totalVotingPower?: string | number | import("long").Long;
                validatorPower?: string | number | import("long").Long;
                timestamp?: Date;
            }): _104.DuplicateVoteEvidence;
            fromAmino(object: _104.DuplicateVoteEvidenceAmino): _104.DuplicateVoteEvidence;
            toAmino(message: _104.DuplicateVoteEvidence): _104.DuplicateVoteEvidenceAmino;
            fromAminoMsg(object: _104.DuplicateVoteEvidenceAminoMsg): _104.DuplicateVoteEvidence;
            fromProtoMsg(message: _104.DuplicateVoteEvidenceProtoMsg): _104.DuplicateVoteEvidence;
            toProto(message: _104.DuplicateVoteEvidence): Uint8Array;
            toProtoMsg(message: _104.DuplicateVoteEvidence): _104.DuplicateVoteEvidenceProtoMsg;
        };
        LightClientAttackEvidence: {
            typeUrl: string;
            encode(message: _104.LightClientAttackEvidence, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _104.LightClientAttackEvidence;
            fromPartial(object: {
                conflictingBlock?: {
                    signedHeader?: {
                        header?: {
                            version?: {
                                block?: string | number | import("long").Long;
                                app?: string | number | import("long").Long;
                            };
                            chainId?: string;
                            height?: string | number | import("long").Long;
                            time?: Date;
                            lastBlockId?: {
                                hash?: Uint8Array;
                                partSetHeader?: {
                                    total?: number;
                                    hash?: Uint8Array;
                                };
                            };
                            lastCommitHash?: Uint8Array;
                            dataHash?: Uint8Array;
                            validatorsHash?: Uint8Array;
                            nextValidatorsHash?: Uint8Array;
                            consensusHash?: Uint8Array;
                            appHash?: Uint8Array;
                            lastResultsHash?: Uint8Array;
                            evidenceHash?: Uint8Array;
                            proposerAddress?: Uint8Array;
                        };
                        commit?: {
                            height?: string | number | import("long").Long;
                            round?: number;
                            blockId?: {
                                hash?: Uint8Array;
                                partSetHeader?: {
                                    total?: number;
                                    hash?: Uint8Array;
                                };
                            };
                            signatures?: {
                                blockIdFlag?: _107.BlockIDFlag;
                                validatorAddress?: Uint8Array;
                                timestamp?: Date;
                                signature?: Uint8Array;
                            }[];
                        };
                    };
                    validatorSet?: {
                        validators?: {
                            address?: Uint8Array;
                            pubKey?: {
                                ed25519?: Uint8Array;
                                secp256k1?: Uint8Array;
                            };
                            votingPower?: string | number | import("long").Long;
                            proposerPriority?: string | number | import("long").Long;
                        }[];
                        proposer?: {
                            address?: Uint8Array;
                            pubKey?: {
                                ed25519?: Uint8Array;
                                secp256k1?: Uint8Array;
                            };
                            votingPower?: string | number | import("long").Long;
                            proposerPriority?: string | number | import("long").Long;
                        };
                        totalVotingPower?: string | number | import("long").Long;
                    };
                };
                commonHeight?: string | number | import("long").Long;
                byzantineValidators?: {
                    address?: Uint8Array;
                    pubKey?: {
                        ed25519?: Uint8Array;
                        secp256k1?: Uint8Array;
                    };
                    votingPower?: string | number | import("long").Long;
                    proposerPriority?: string | number | import("long").Long;
                }[];
                totalVotingPower?: string | number | import("long").Long;
                timestamp?: Date;
            }): _104.LightClientAttackEvidence;
            fromAmino(object: _104.LightClientAttackEvidenceAmino): _104.LightClientAttackEvidence;
            toAmino(message: _104.LightClientAttackEvidence): _104.LightClientAttackEvidenceAmino;
            fromAminoMsg(object: _104.LightClientAttackEvidenceAminoMsg): _104.LightClientAttackEvidence;
            fromProtoMsg(message: _104.LightClientAttackEvidenceProtoMsg): _104.LightClientAttackEvidence;
            toProto(message: _104.LightClientAttackEvidence): Uint8Array;
            toProtoMsg(message: _104.LightClientAttackEvidence): _104.LightClientAttackEvidenceProtoMsg;
        };
        EvidenceList: {
            typeUrl: string;
            encode(message: _104.EvidenceList, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _104.EvidenceList;
            fromPartial(object: {
                evidence?: {
                    duplicateVoteEvidence?: {
                        voteA?: {
                            type?: _106.SignedMsgType;
                            height?: string | number | import("long").Long;
                            round?: number;
                            blockId?: {
                                hash?: Uint8Array;
                                partSetHeader?: {
                                    total?: number;
                                    hash?: Uint8Array;
                                };
                            };
                            timestamp?: Date;
                            validatorAddress?: Uint8Array;
                            validatorIndex?: number;
                            signature?: Uint8Array;
                            extension?: Uint8Array;
                            extensionSignature?: Uint8Array;
                        };
                        voteB?: {
                            type?: _106.SignedMsgType;
                            height?: string | number | import("long").Long;
                            round?: number;
                            blockId?: {
                                hash?: Uint8Array;
                                partSetHeader?: {
                                    total?: number;
                                    hash?: Uint8Array;
                                };
                            };
                            timestamp?: Date;
                            validatorAddress?: Uint8Array;
                            validatorIndex?: number;
                            signature?: Uint8Array;
                            extension?: Uint8Array;
                            extensionSignature?: Uint8Array;
                        };
                        totalVotingPower?: string | number | import("long").Long;
                        validatorPower?: string | number | import("long").Long;
                        timestamp?: Date;
                    };
                    lightClientAttackEvidence?: {
                        conflictingBlock?: {
                            signedHeader?: {
                                header?: {
                                    version?: {
                                        block?: string | number | import("long").Long;
                                        app?: string | number | import("long").Long;
                                    };
                                    chainId?: string;
                                    height?: string | number | import("long").Long;
                                    time?: Date;
                                    lastBlockId?: {
                                        hash?: Uint8Array;
                                        partSetHeader?: {
                                            total?: number;
                                            hash?: Uint8Array;
                                        };
                                    };
                                    lastCommitHash?: Uint8Array;
                                    dataHash?: Uint8Array;
                                    validatorsHash?: Uint8Array;
                                    nextValidatorsHash?: Uint8Array;
                                    consensusHash?: Uint8Array;
                                    appHash?: Uint8Array;
                                    lastResultsHash?: Uint8Array;
                                    evidenceHash?: Uint8Array;
                                    proposerAddress?: Uint8Array;
                                };
                                commit?: {
                                    height?: string | number | import("long").Long;
                                    round?: number;
                                    blockId?: {
                                        hash?: Uint8Array;
                                        partSetHeader?: {
                                            total?: number;
                                            hash?: Uint8Array;
                                        };
                                    };
                                    signatures?: {
                                        blockIdFlag?: _107.BlockIDFlag;
                                        validatorAddress?: Uint8Array;
                                        timestamp?: Date;
                                        signature?: Uint8Array;
                                    }[];
                                };
                            };
                            validatorSet?: {
                                validators?: {
                                    address?: Uint8Array;
                                    pubKey?: {
                                        ed25519?: Uint8Array;
                                        secp256k1?: Uint8Array;
                                    };
                                    votingPower?: string | number | import("long").Long;
                                    proposerPriority?: string | number | import("long").Long;
                                }[];
                                proposer?: {
                                    address?: Uint8Array;
                                    pubKey?: {
                                        ed25519?: Uint8Array;
                                        secp256k1?: Uint8Array;
                                    };
                                    votingPower?: string | number | import("long").Long;
                                    proposerPriority?: string | number | import("long").Long;
                                };
                                totalVotingPower?: string | number | import("long").Long;
                            };
                        };
                        commonHeight?: string | number | import("long").Long;
                        byzantineValidators?: {
                            address?: Uint8Array;
                            pubKey?: {
                                ed25519?: Uint8Array;
                                secp256k1?: Uint8Array;
                            };
                            votingPower?: string | number | import("long").Long;
                            proposerPriority?: string | number | import("long").Long;
                        }[];
                        totalVotingPower?: string | number | import("long").Long;
                        timestamp?: Date;
                    };
                }[];
            }): _104.EvidenceList;
            fromAmino(object: _104.EvidenceListAmino): _104.EvidenceList;
            toAmino(message: _104.EvidenceList): _104.EvidenceListAmino;
            fromAminoMsg(object: _104.EvidenceListAminoMsg): _104.EvidenceList;
            fromProtoMsg(message: _104.EvidenceListProtoMsg): _104.EvidenceList;
            toProto(message: _104.EvidenceList): Uint8Array;
            toProtoMsg(message: _104.EvidenceList): _104.EvidenceListProtoMsg;
        };
        Block: {
            typeUrl: string;
            encode(message: _103.Block, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _103.Block;
            fromPartial(object: {
                header?: {
                    version?: {
                        block?: string | number | import("long").Long;
                        app?: string | number | import("long").Long;
                    };
                    chainId?: string;
                    height?: string | number | import("long").Long;
                    time?: Date;
                    lastBlockId?: {
                        hash?: Uint8Array;
                        partSetHeader?: {
                            total?: number;
                            hash?: Uint8Array;
                        };
                    };
                    lastCommitHash?: Uint8Array;
                    dataHash?: Uint8Array;
                    validatorsHash?: Uint8Array;
                    nextValidatorsHash?: Uint8Array;
                    consensusHash?: Uint8Array;
                    appHash?: Uint8Array;
                    lastResultsHash?: Uint8Array;
                    evidenceHash?: Uint8Array;
                    proposerAddress?: Uint8Array;
                };
                data?: {
                    txs?: Uint8Array[];
                };
                evidence?: {
                    evidence?: {
                        duplicateVoteEvidence?: {
                            voteA?: {
                                type?: _106.SignedMsgType;
                                height?: string | number | import("long").Long;
                                round?: number;
                                blockId?: {
                                    hash?: Uint8Array;
                                    partSetHeader?: {
                                        total?: number;
                                        hash?: Uint8Array;
                                    };
                                };
                                timestamp?: Date;
                                validatorAddress?: Uint8Array;
                                validatorIndex?: number;
                                signature?: Uint8Array;
                                extension?: Uint8Array;
                                extensionSignature?: Uint8Array;
                            };
                            voteB?: {
                                type?: _106.SignedMsgType;
                                height?: string | number | import("long").Long;
                                round?: number;
                                blockId?: {
                                    hash?: Uint8Array;
                                    partSetHeader?: {
                                        total?: number;
                                        hash?: Uint8Array;
                                    };
                                };
                                timestamp?: Date;
                                validatorAddress?: Uint8Array;
                                validatorIndex?: number;
                                signature?: Uint8Array;
                                extension?: Uint8Array;
                                extensionSignature?: Uint8Array;
                            };
                            totalVotingPower?: string | number | import("long").Long;
                            validatorPower?: string | number | import("long").Long;
                            timestamp?: Date;
                        };
                        lightClientAttackEvidence?: {
                            conflictingBlock?: {
                                signedHeader?: {
                                    header?: {
                                        version?: {
                                            block?: string | number | import("long").Long;
                                            app?: string | number | import("long").Long;
                                        };
                                        chainId?: string;
                                        height?: string | number | import("long").Long;
                                        time?: Date;
                                        lastBlockId?: {
                                            hash?: Uint8Array;
                                            partSetHeader?: {
                                                total?: number;
                                                hash?: Uint8Array;
                                            };
                                        };
                                        lastCommitHash?: Uint8Array;
                                        dataHash?: Uint8Array;
                                        validatorsHash?: Uint8Array;
                                        nextValidatorsHash?: Uint8Array;
                                        consensusHash?: Uint8Array;
                                        appHash?: Uint8Array;
                                        lastResultsHash?: Uint8Array;
                                        evidenceHash?: Uint8Array;
                                        proposerAddress?: Uint8Array;
                                    };
                                    commit?: {
                                        height?: string | number | import("long").Long;
                                        round?: number;
                                        blockId?: {
                                            hash?: Uint8Array;
                                            partSetHeader?: {
                                                total?: number;
                                                hash?: Uint8Array;
                                            };
                                        };
                                        signatures?: {
                                            blockIdFlag?: _107.BlockIDFlag;
                                            validatorAddress?: Uint8Array;
                                            timestamp?: Date;
                                            signature?: Uint8Array;
                                        }[];
                                    };
                                };
                                validatorSet?: {
                                    validators?: {
                                        address?: Uint8Array;
                                        pubKey?: {
                                            ed25519?: Uint8Array;
                                            secp256k1?: Uint8Array;
                                        };
                                        votingPower?: string | number | import("long").Long;
                                        proposerPriority?: string | number | import("long").Long;
                                    }[];
                                    proposer?: {
                                        address?: Uint8Array;
                                        pubKey?: {
                                            ed25519?: Uint8Array;
                                            secp256k1?: Uint8Array;
                                        };
                                        votingPower?: string | number | import("long").Long;
                                        proposerPriority?: string | number | import("long").Long;
                                    };
                                    totalVotingPower?: string | number | import("long").Long;
                                };
                            };
                            commonHeight?: string | number | import("long").Long;
                            byzantineValidators?: {
                                address?: Uint8Array;
                                pubKey?: {
                                    ed25519?: Uint8Array;
                                    secp256k1?: Uint8Array;
                                };
                                votingPower?: string | number | import("long").Long;
                                proposerPriority?: string | number | import("long").Long;
                            }[];
                            totalVotingPower?: string | number | import("long").Long;
                            timestamp?: Date;
                        };
                    }[];
                };
                lastCommit?: {
                    height?: string | number | import("long").Long;
                    round?: number;
                    blockId?: {
                        hash?: Uint8Array;
                        partSetHeader?: {
                            total?: number;
                            hash?: Uint8Array;
                        };
                    };
                    signatures?: {
                        blockIdFlag?: _107.BlockIDFlag;
                        validatorAddress?: Uint8Array;
                        timestamp?: Date;
                        signature?: Uint8Array;
                    }[];
                };
            }): _103.Block;
            fromAmino(object: _103.BlockAmino): _103.Block;
            toAmino(message: _103.Block): _103.BlockAmino;
            fromAminoMsg(object: _103.BlockAminoMsg): _103.Block;
            fromProtoMsg(message: _103.BlockProtoMsg): _103.Block;
            toProto(message: _103.Block): Uint8Array;
            toProtoMsg(message: _103.Block): _103.BlockProtoMsg;
        };
    };
    const version: {
        App: {
            typeUrl: string;
            encode(message: _108.App, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _108.App;
            fromPartial(object: {
                protocol?: string | number | import("long").Long;
                software?: string;
            }): _108.App;
            fromAmino(object: _108.AppAmino): _108.App;
            toAmino(message: _108.App): _108.AppAmino;
            fromAminoMsg(object: _108.AppAminoMsg): _108.App;
            fromProtoMsg(message: _108.AppProtoMsg): _108.App;
            toProto(message: _108.App): Uint8Array;
            toProtoMsg(message: _108.App): _108.AppProtoMsg;
        };
        Consensus: {
            typeUrl: string;
            encode(message: _108.Consensus, writer?: import("protobufjs").Writer): import("protobufjs").Writer;
            decode(input: Uint8Array | import("protobufjs").Reader, length?: number): _108.Consensus;
            fromPartial(object: {
                block?: string | number | import("long").Long;
                app?: string | number | import("long").Long;
            }): _108.Consensus;
            fromAmino(object: _108.ConsensusAmino): _108.Consensus;
            toAmino(message: _108.Consensus): _108.ConsensusAmino;
            fromAminoMsg(object: _108.ConsensusAminoMsg): _108.Consensus;
            fromProtoMsg(message: _108.ConsensusProtoMsg): _108.Consensus;
            toProto(message: _108.Consensus): Uint8Array;
            toProtoMsg(message: _108.Consensus): _108.ConsensusProtoMsg;
        };
    };
}
